/* @(#) $Id: HtmlDigitalSignatureCmd.js,v 1.10 2011/07/02 17:14:07 subrata Exp $ */

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is  Avaya Labs Research, Avaya Inc. Code.
 *
 * The Initial Developer of the Original Code is
 *     Subrata Mazumdar, Avaya Labs Research, Avaya Inc.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Subrata Mazumdar (mazum@avaya.com)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


function xmldsigffext_signXMLDocWithSharedKey(/* nsIDOMDocument  */ xmlDoc, /* nsIPersistentProperties */ xmlSignatureProps)
{
    // dump("xmldsigffext_signXMLDocWithSharedKey():................Start.\n");

    var outSignedXmlDoc = null;
    try {
    	outSignedXmlDoc = gXmlDSigTool.signXMLDocBySharedKey(xmlDoc, xmlSignatureProps);
    } catch (ex) {
    	// alert("xmldsigffext_signXMLFileWithSharedKey(): failed to create signed XML file - ex : " + ex + "\n");
    	dump("xmldsigffext_signXMLDocWithSharedKey(): failed to create signed XML file - ex : " + ex + "\n");
	throw ex;
    }

    // dump("xmldsigffext_signXMLDocWithSharedKey():................End.\n");

    return outSignedXmlDoc;

}


/* nsIDOMDocument  */
function xmldsigffext_signXMLDocWithCert(/* nsIDOMDocument  */ xmlDoc, /* nsIX509Cert */ signerCert, /* nsIPersistentProperties */ xmlSignatureProps)
{
    // dump("xmldsigffext_signXMLDocWithCert():................Start.\n");

    var outSignedXmlDoc = null;
    try {
    	// Force token login - on windows the popup window for password is not coming up
    	xmldsigffext_loginToCertToken(signerCert);
    	outSignedXmlDoc = gXmlDSigTool.signXMLDocByX509Cert(xmlDoc, signerCert, xmlSignatureProps);
    } catch (ex) {
    	alert("xmldsigffext_signXMLDocWithCert(): failed to sign XML file - ex : " + ex + "\n");
    	dump("xmldsigffext_signXMLDocWithCert(): failed to sign XML file - ex : " + ex + "\n");
	throw ex;
    }

    // dump("xmldsigffext_signXMLDocWithCert():................End.\n");

    return outSignedXmlDoc;
}


/* nsIDOMDocument */
function xmldsigffext_signHTMLDoc()
{
    dump("xmldsigffext_signHTMLDoc():................Start.\n");

    dump("xmldsigffext_signHTMLDoc():................End.\n");
    return detachedSigXmlDoc;

}

/* nsIDOMDocument */
function XXXX_xmldsigffext_signHTMLDoc()
{
    // dump("xmldsigffext_signHTMLDoc():................Start.\n");


    var detachedSigXmlDoc = null;
    var xmlDocWithSigTransforms = gHtmlDSigEditorElem.getXmlDocWithSigTransforms();
    if (!xmlDocWithSigTransforms) {
	dump("xmldsigffext_signHTMLDoc(): getXmlDocWithSigTransforms() failed - NULL XML doc.\n");
    	return null;
    }
    var /* nsIPersistentProperties */ xmlSignatureProps = gHtmlDSigEditorElem.getSignatureProperties();

    /*
    var xmlDocWithSigTransformsStr = gHtmlDSigEditorElem.serialize(xmlDocWithSigTransforms);
    dump("xmldsigffext_signHTMLDoc(): xmlDocWithSigTransformsStr: \n" + xmlDocWithSigTransformsStr + "\n\n");
    gHtmlDSigEditorElem.dumpProperties(xmlSignatureProps, "Signing Props:");
    */

    var detachedSigXmlDoc = null;
    // var credentialType = xmldsigffext_getUserCredentialType();
    var credentialType = gHtmlDSigEditorElem.credentialType;
    if (credentialType == "certificate") {
        var /* nsIX509Cert */ signerCert;
        signerCert = gHtmlDSigEditorElem.signerCert;
        if (signerCert == null) {
    	    dump("xmldsigffext_signHTMLDoc(): null signerCert - you must choose a signing certificate.\n");
    	    alert("xmldsigffext_signHTMLDoc(): null signerCert - you must choose a signing certificate.\n");
    	    return null;
        }
    	detachedSigXmlDoc = xmldsigffext_signXMLDocWithCert(xmlDocWithSigTransforms, signerCert, xmlSignatureProps);
    }
    else if (credentialType == "password") {
    	var sharedKey = gHtmlDSigEditorElem.signerSharedKey;
        if (sharedKey.length == 0) {
    	    alert("xmldsigffext_signHTMLDoc(): shared key is missing.\n");
    	    dump("xmldsigffext_signHTMLDoc(): shared key is missing.\n");
    	    return null;
        }
    	detachedSigXmlDoc = xmldsigffext_signXMLDocWithSharedKey(xmlDocWithSigTransforms, xmlSignatureProps);
    }
    else {
    	detachedSigXmlDoc = null;
    }
    if (!detachedSigXmlDoc) {
    	return null;
    }

    // dump("xmldsigffext_signHTMLDoc():................End.\n");
    return detachedSigXmlDoc;
}

/* nsIDOMDocument */
function xmldsigffext_signHTMLDocToFile()
{
    // dump("xmldsigffext_signHTMLDocToFile():................Start.\n");

    if (!gHtmlDSigXmlOutFilePickerElem.file) {
    	alert("Output Signature XML file path is missing.");
    	dump("xmldsigffext_signHTMLDocToFile(): Output Signature XML file path is missing.\n");
    	return null;
    }

    if (!gHtmlDSigHtmlOutFilePickerElem.file) {
    	alert("Output Signed HTML doc file path is missing.");
    	dump("xmldsigffext_signHTMLDocToFile(): Output Signed HTML doc file path is missing.\n");
    	return null;
    }

    // Select path to the signed XML File 
    /*
    var retVal = xmldsigffext_htmldsig_autoSelectOutFiles();
    if (!retVal) {
    	alert("Failed to auto-select output files.");
    	return null;
    }
    */

    // Save signed HTML doc with with signature link 
    // dump("xmldsigffext_signHTMLDocToFile(): gHtmlDSigHtmlOutFilePickerElem: " + gHtmlDSigHtmlOutFilePickerElem.filepath + "\n");
    var signedHtmlDoc = gHtmlDSigEditorElem.signedHtmlDoc;
    var signedHtmlDocStr = gXmlSerializer.serializeToString(signedHtmlDoc);
    gHtmlDSigHtmlOutFilePickerElem.saveFile(signedHtmlDocStr);
    gHtmlDSigHtmlOutFilePickerElem.refresh();
    gHtmlDSigHtmlOutFileVerifyElem.hidden = false;
    
    // Create signed XML doc 
    var /* nsIDOMDocument */ detachedSigXmlDoc = null;
    // detachedSigXmlDoc = xmldsigffext_signHTMLDoc();
    detachedSigXmlDoc = gHtmlDSigEditorElem.signHTMLDoc();

    if (!detachedSigXmlDoc) {
    	dump("xmldsigffext_signHTMLDocToFile(): gHtmlDSigEditorElem.signHTMLDoc() failed.\n");
    	return null;
    }

    // Save signature XML doc 
    // dump("xmldsigffext_signHTMLDocToFile(): gHtmlDSigXmlOutFilePickerElem: " + gHtmlDSigXmlOutFilePickerElem.filepath + "\n");
    var detachedSigXmlDocStr = gXmlSerializer.serializeToString(detachedSigXmlDoc);
    // dump("xmldsigffext_signHTMLDocToFile(): detachedSigXmlDoc:\n" + detachedSigXmlDocStr + "\n");
    gHtmlDSigXmlOutFilePickerElem.saveFile(detachedSigXmlDocStr);
    gHtmlDSigXmlOutFilePickerElem.refresh();

    gHtmlDSigXmlOutFileVerifyElem.hidden = false;

    // dump("xmldsigffext_signHTMLDocToFile():................End.\n");
    return detachedSigXmlDoc;
}

function xmldsigffext_verifySignedXMLDocWithSharedKey(aDetachedSigXmlDoc, xmlSignatureProps)
{
    // dump("xmldsigffext_verifySignedXMLDocWithSharedKey():................Start.\n");

    var sharedKey = gHtmlDSigEditorElem.signerSharedKey;
    if (!sharedKey || (sharedKey == "")) {
	sharedKey = propmptAndGetPassword(
		"Enter the Signing Key",
		"This document is signed with symmetric key - enter the key used to sign the document"
		)
	if (!sharedKey || (sharedKey == "")) { 
	    // alert("Password is missing - enter a password.");
    	    return false;
	}
	gHtmlDSigEditorElem.signerSharedKey = sharedKey;
    }
    /*
    if (sharedKey == "") {
	alert("Password is missing - enter a password.");
    	return false;
    }
    */

    var isPassed = false;
    try {
    	isPassed = gXmlDSigTool.verifySignedXMLDocBySharedKey(
                        aDetachedSigXmlDoc,
			sharedKey,
			xmlSignatureProps
                        );
    } catch (ex) {
    	dump("xmldsigffext_verifySignedXMLDocWithSharedKey(): failed to verify signed archive file - ex : " + ex + "\n");
	throw ex;
    }

    // dump("xmldsigffext_verifySignedXMLDocWithSharedKey():................End.\n");
    return isPassed;
}


function xmldsigffext_verifySignedXMLDocByX509Cert(aDetachedSigXmlDoc, xmlSignatureProps)
{
    // dump("xmldsigffext_verifySignedXMLDocByX509Cert():................Start.\n");

    var /* nsIX509Cert */ docSignerCert = null;
    var signerCertObj = new Object();
    var isPassed = false;
    try {
    	docSignerCert = gHtmlDSigEditorElem.docSignerCert;
    	// dump("xmldsigffext_verifySignedXMLDocByX509Cert(): docSignerCert: " + docSignerCert + "\n");
	if (docSignerCert) {
    	// dump("xmldsigffext_verifySignedXMLDocByX509Cert(): docSignerCert: " + docSignerCert.nickname + "\n");
	}
	signerCertObj.value = gHtmlDSigEditorElem.docSignerCert;
    	isPassed = gXmlDSigTool.verifySignedXMLDocByX509Cert(
                        aDetachedSigXmlDoc,
			signerCertObj,
			xmlSignatureProps
                        );
    } catch (ex) {
    	dump("xmldsigffext_verifySignedXMLDocByX509Cert(): failed to verify signed archive file - ex : " + ex + "\n");
	isPassed = false;
	// throw ex;
    }
    /*
    if (!docSignerCert) {
	docSignerCert = signerCertObj.value;
    	dump("xmldsigffext_verifySignedXMLDocByX509Cert(): signerCertObj.value: " + signerCertObj.value + "\n");
	if (docSignerCert) {
    	    gHtmlDSigEditorElem.docSignerCert = docSignerCert;
    	    xmldsigffext_showXmlDocSignerCert(signerCertObj.value);
    	    dump("xmldsigffext_verifySignedXMLDocByX509Cert():x509Cert.dbKey: " + signerCertObj.value.dbKey + "\n");
	}
    }
    */

    // dump("xmldsigffext_verifySignedXMLDocByX509Cert():................End.\n");
    return isPassed;
}

function xmldsigffext_verifySignedHTMLDoc()
{
    dump("xmldsigffext_verifySignedHTMLDoc():................Start.\n");

    var validHtmlDocSig = gHtmlDSigEditorElem.htmlSignatureValidator.validateSignedHtmlURI(gHtmlDSigEditorElem.htmlDocURISpec);
    if (!validHtmlDocSig) {
    	alert("HTML Signature is ** NOT VALID ** accroding to the signature profile - may be some reference/manifest element is not present.\n");
	return false;
    }

    var /* nsIPersistentProperties */ xmlSignatureProps = gHtmlDSigEditorElem.getSignatureProperties();
    var /* nsIDOMDocument */ detachedSigXmlDoc = gHtmlDSigEditorElem.htmlDocSigXmlDoc;
    dump("detachedSigXmlDoc:\n" + gHtmlDSigEditorElem.serialize(detachedSigXmlDoc.documentElement));

    var isPassed = false;
    var credentialType = gHtmlDSigEditorElem.credentialType;
    if (credentialType == "certificate") {
    	isPassed = xmldsigffext_verifySignedXMLDocByX509Cert(detachedSigXmlDoc, xmlSignatureProps);
    }
    else {
    	isPassed = xmldsigffext_verifySignedXMLDocWithSharedKey(detachedSigXmlDoc, xmlSignatureProps);
    }

    var errorMessage = null;
    if (!isPassed) {
	try {
	    var propKey = "errorMessage";
	    errorMessage = xmlSignatureProps.getStringProperty(propKey);
	} catch(ex) { }
	if (errorMessage) {
	    alert("XML Signature verification failed - " + errorMessage + "\n");
	}
    }


    dump("xmldsigffext_verifySignedHTMLDoc():................End.\n");
    return isPassed;
}



function xmldsigffext_signXMLFileWithSharedKey(/* nsIPersistentProperties */ xmlSignatureProps)
{
    // dump("xmldsigffext_signXMLFileWithSharedKey():................Start.\n");

    var /* nsILocalFile */ inputXMLFile = gHtmlInputFilePickerElem.file;
    if (inputXMLFile == null) {
    	dump("xmldsigffext_signXMLFileWithSharedKey(): No input XML file is selected.\n");
    	return null;
    }

    var /* nsILocalFile */ outSignedXMLFile = gHtmlDSigXmlOutFilePickerElem.file;
    if (outSignedXMLFile == null) {
    	dump("xmldsigffext_signXMLFileWithSharedKey(): failed to get outSignedXMLFile.\n");
        return null;
    }

    try {
    	gXmlDSigTool.signXMLFileBySharedKey(inputXMLFile, xmlSignatureProps, outSignedXMLFile);
    } catch (ex) {
    	// alert("xmldsigffext_signXMLFileWithSharedKey(): failed to create signed XML file - ex : " + ex + "\n");
    	dump("xmldsigffext_signXMLFileWithSharedKey(): failed to create signed XML file - ex : " + ex + "\n");
	throw ex;
    }

    // dump("xmldsigffext_signXMLFileWithSharedKey():................End.\n");

    return outSignedXMLFile;
}

function xmldsigffext_signXMLFileWithCert(/* nsIPersistentProperties */ xmlSignatureProps)
{
    // dump("xmldsigffext_signXMLFileWithCert():................Start.\n");

    var /* nsIX509Cert */ signerCert;
    signerCert = gHtmlDSigEditorElem.signerCert;
    if (signerCert == null) {
    	alert("xmldsigffext_signXMLFileWithCert(): null signer certificate - you must choose a signer certificate.");
    	dump("xmldsigffext_signXMLFileWithCert(): null signer certificate - you must choose a signer certificate.\n");
    	return null;
    }

    var /* nsILocalFile */ inputXMLFile = gHtmlInputFilePickerElem.file;
    if (inputXMLFile == null) {
    	dump("xmldsigffext_signXMLFileWithCert(): No input XML file is selected.\n");
    	return null;
    }

    var /* nsILocalFile */ outSignedXMLFile = gHtmlDSigXmlOutFilePickerElem.file;
    if (outSignedXMLFile == null) {
    	dump("xmldsigffext_signXMLFileWithCert(): failed to get outSignedXMLFile.\n");
        return null;
    }

    try {
    	// Force token login - on windows the popup window for password is not coming up
    	xmldsigffext_loginToCertToken(signerCert);

    	// dumpProperties(xmlSignatureProps, "xmldsigffext_signXMLFileWithCert(): xmlSignatureParams:");
    	gXmlDSigTool.signXMLFileByX509Cert(inputXMLFile, signerCert, xmlSignatureProps, outSignedXMLFile);
    } catch (ex) {
    	// alert("xmldsigffext_signXMLFileWithCert(): failed to create signed XML file - ex : " + ex + "\n");
    	dump("xmldsigffext_signXMLFileWithCert(): failed to create signed XML file - ex : " + ex + "\n");
	throw ex;
    }

    // dump("xmldsigffext_signXMLFileWithCert():................End.\n");

    return outSignedXMLFile;
}

function xmldsigffext_signXMLFile()
{
    // dump("xmldsigffext_signXMLFile():................Start.\n");

    var /* nsIPersistentProperties */ xmlSignatureProps = gHtmlDSigEditorElem.getSignatureProperties();
    var /* nsIPersistentProperties */ xmlSigProps = Components.classes["@mozilla.org/persistent-properties;1"].
                    createInstance(Components.interfaces.nsIPersistentProperties);

    var /* nsILocalFile */ inputXMLFile = gHtmlInputFilePickerElem.file;
    if (inputXMLFile == null) {
    	dump("xmldsigffext_signXMLFile(): No input XML file is selected.\n");
    	alert("xmldsigffext_signXMLFile(): No input XML file is selected.\n");
    	return null;
    }

    var /* nsILocalFile */ outSignedXMLFile = null;
    if (gHtmlDSigXmlOutFilePickerElem.value == "") {
	xmldsigffext_autoSelectOutSignedFile(inputXMLFile);
    }
    outSignedXMLFile = gHtmlDSigXmlOutFilePickerElem.file;
    if (outSignedXMLFile == null) {
    	dump("xmldsigffext_signXMLFile(): failed to get outSignedXMLFile.\n");
    	alert("xmldsigffext_signXMLFile(): failed to get outSignedXMLFile.\n");
        return null;
    }
    // dump("xmldsigffext_signXMLFile(): outSignedXMLFile: " + outSignedXMLFile.path + "\n");


    // var credentialType = xmldsigffext_getUserCredentialType();
    var credentialType = gHtmlDSigEditorElem.credentialType;
    if (credentialType == "certificate") {
    	outSignedXMLFile = xmldsigffext_signXMLFileWithCert(xmlSignatureProps);
    }
    else if (credentialType == "password") {
    	var sharedKey = gHtmlDSigEditorElem.signerSharedKey;
        if (sharedKey.length == 0) {
    	    alert("xmldsigffext_signXMLFileWithSharedKey(): shared key is missing.\n");
    	    dump("xmldsigffext_signXMLFileWithSharedKey(): shared key is missing.\n");
    	    return null;
        }
    	outSignedXMLFile = xmldsigffext_signXMLFileWithSharedKey(xmlSignatureProps);
    }
    else {
    	outSignedXMLFile = null;
    }

    if (!outSignedXMLFile) {
    	dump("xmldsigffext_signXMLFile(): failed to sign input XML file.\n");
	return null;
    }

    gHtmlDSigXmlOutFilePickerElem.refresh();
    outSignedXMLFile = gHtmlDSigXmlOutFilePickerElem.file;
    if (!outSignedXMLFile || !outSignedXMLFile.exists() || (outSignedXMLFile.fileSize <= 0)) {
    	dump("xmldsigffext_signXMLFile(): failed to create Signed XML file.\n");
    	// alert("xmldsigffext_signXMLFile(): failed to create Signed XML file.\n");
	return null;
    }

    // dump("xmldsigffext_signXMLFile():................End.\n");

    return gHtmlDSigXmlOutFilePickerElem.file;
}

function propmptAndGetPassword(aPromptWinTitle, aPromptMsg)
{
    var checkStateMsg = null;
    var checkStateObj = new Object();
    checkStateObj.value = null;
    var passwordObj = new Object();
    passwordObj.value = null;

    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService();
    promptService = promptService.QueryInterface(Components.interfaces.nsIPromptService);
    var dialogOk = promptService.promptPassword(
			window,
			aPromptWinTitle,
			aPromptMsg,
			passwordObj,
			checkStateMsg,
			checkStateObj
		     	);
    if (!dialogOk) {
	return null;
    }
    return passwordObj.value;
}

function xmldsigffext_verifySignedXMLFileWithSharedKey(xmlSignatureProps)
{
    // dump("xmldsigffext_verifySignedXMLFileWithSharedKey():................Start.\n");

    var signedXmlFile = gHtmlInputFileURIElem.file;

    var sharedKey = gHtmlDSigEditorElem.signerSharedKey;
    if (sharedKey == "") {
	var promptWinTitle = "Enter the Signing Key";
	var promptMsg = "This document is signed with symmetric key - enter the key used to sign the document"
	sharedKey = propmptAndGetPassword( promptWinTitle, promptMsg)
	if (!sharedKey || (sharedKey == "")) { 
	    // alert("Password is missing - enter a password.");
    	    return false;
	}
	gHtmlDSigEditorElem.signerSharedKey = sharedKey;
    }

    var isPassed = false;
    try {
    	/*
        boolean verifySignedXMLFileByX509Cert(
	    	in nsILocalFile aSignedXmlFile,
		in AString sharedKey,
		in nsIPersistentProperties aSignatureProps
		);
	*/
    	isPassed = gXmlDSigTool.verifySignedXMLFileBySharedKey(
                        signedXmlFile,
			sharedKey,
			xmlSignatureProps
                        );
    } catch (ex) {
    	dump("xmldsigffext_verifySignedXMLFileWithSharedKey to verify signed XML file - ex : " + ex + "\n");
	throw ex;
    }

    // dump("xmldsigffext_verifySignedXMLFileWithSharedKey():................Start.\n");
    return isPassed;
}

function xmldsigffext_verifySignedXMLFileWithX509Cert(xmlSignatureProps)
{
    // dump("xmldsigffext_verifySignedXMLFileWithX509Cert():................Start.\n");

    var signedXmlFile = gHtmlInputFilePickerElem.file;

    var /* nsIX509Cert */ docSignerCert = null;
    var signerCertObj = new Object();
    var isPassed = false;
    try {
    	docSignerCert = gHtmlDSigEditorElem.docSignerCert;
	/*
	if (docSignerCert) {
    	dump("xmldsigffext_verifySignedXMLFileWithX509Cert(): docSignerCert: " + docSignerCert.nickname + "\n");
	}
	*/
	signerCertObj.value = gHtmlDSigEditorElem.docSignerCert;
    	isPassed = gXmlDSigTool.verifySignedXMLFileByX509Cert(
                        signedXmlFile,
			signerCertObj,
			xmlSignatureProps
                        );
    } catch (ex) {
    	dump("xmldsigffext_verifySignedXMLFileWithX509Cert(): failed to verify signed XML file - ex : " + ex + "\n");
	throw ex;
    }
    /*
    if (!signerCert) {
    	// gXmlDSigDocSignerCertElem.cert = signerCertObj.value;
    	if (signerCertObj.value) {
    	    xmldsigffext_showXmlDocSignerCert(signerCertObj.value);
    	    dump("xmldsigffext_verifySignedXMLFileWithX509Cert():x509Cert.dbKey: " + signerCertObj.value.dbKey + "\n");
    	}
    }
    */

    // dump("xmldsigffext_verifySignedXMLFileWithX509Cert():................End.\n");
    return isPassed;
}

function xmldsigffext_verifySignedXMLFile()
{
    // dump("xmldsigffext_verifySignedXMLFile():................Start.\n");

    var /* nsIPersistentProperties */ xmlSigProps = gHtmlDSigEditorElem.getSignatureProperties();

    var isPassed = false;
    var credentialType = gHtmlDSigEditorElem.credentialType;
    if (credentialType.value == "certificate") {
    	isPassed = xmldsigffext_verifySignedXMLFileWithX509Cert(xmlSignatureProps);
    }
    else {
    	isPassed = xmldsigffext_verifySignedXMLFileWithSharedKey(xmlSignatureProps);
    }

    // dump("xmldsigffext_verifySignedXMLFile():................End.\n");
    return isPassed;
}



