/* @(#) $Id: SamlSelfToken.js,v 1.25 2012/10/03 23:08:09 subrata Exp $ */

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is  Avaya Labs Research, Avaya Inc. Code.
 *
 * The Initial Developer of the Original Code is
 *     Subrata Mazumdar, Avaya Labs Research, Avaya Inc.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Subrata Mazumdar (mazum@avaya.com)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */



var gParams = null;

var gSamlTokenWizardInitDone = false;
var gSamlTokenWizardElem;
var gWizardButtonNextElem;
var gWizardButtonBackElem;
var gWizardButtonFinishElem;
var gWizardButtonExtra1Elem;
var gWizardButtonExtra2Elem;
var gWizardButtonCancelElem;
var gWizardButtonNextOrigLabel;

/*
var gTabboxElem;
var gSignTabElem;
var gVerifyTabElem;

var gSignCmdButtonElem;
var gVerifyCmdButtonElem;
*/

function samlSelfToken_initOnLoad()
{
    if (gSamlTokenWizardInitDone) {
    	return;
    }

    XmlDSigToolFormUtil.logTrace("samlSelfToken_initOnLoad():................Start.\n");
    gSamlTokenWizardInitDone = true;

    // samlSelfToken_isSupportedOS();
    xmldsigffext_isSupportedOS();

    gSamlTokenWizardElem = document.getElementById('samltoken.form.wizard');
    gWizardButtonNextElem = gSamlTokenWizardElem.getButton("next");
    gWizardButtonNextOrigLabel = "" + gWizardButtonNextElem.label;

    gWizardButtonFinishElem = gSamlTokenWizardElem.getButton("finish");
    gWizardButtonExtra1Elem = gSamlTokenWizardElem.getButton("extra1");
    // gWizardButtonExtra1Elem.label = "TTTTTT";
    // XmlDSigToolFormUtil.logDebug("gWizardButtonNextOrigLabel: " + gWizardButtonNextOrigLabel + "\n");

    /*
    var smalTokenFinishStepElem = document.getElementById('samltoken.form.create.workflow.steps.finish');
    smalTokenFinishWizardPageElem.setAttribute("cmdPageId", "samltoken.form.xmldoc.finish");
    */

    SamlSelfTokenCreateWorkFlowInit_initOnLoad(gSamlTokenWizardElem);

    // Initialize the SamlToken create pages
    SamlSelfTokenCreate_initOnLoad(gSamlTokenWizardElem);

    // Initialize the XML Doc Signing and Encryptuion pages
    xmldsigffext_SigEncOverlay_initOnLoad(gSamlTokenWizardElem);

    gWizardButtonExtra1Elem.addEventListener('command', handleExtra1CmdEvent, false);


    samlSelfToken_initParamsOnLoad();

    /**********************************************/
    /* TODO:  TEST CODE - remove after test phase */
    /**********************************************/
    var testMode = avxmldsig.dsigtool.PrefUtil.getPreference("xmldsigffext.test", false);
    if (testMode) {
    try {
    	var tokenPassword = "abcd1234";
    	var tokendb = Components.classes["@mozilla.org/security/pk11tokendb;1"].
                            getService(Components.interfaces.nsIPK11TokenDB);
	var token = tokendb.getInternalKeyToken();
	if (token) {
    	    token.checkPassword(tokenPassword);
	    token.login(false);
	}
    } catch (ex) {}
    }

    XmlDSigToolFormUtil.logTrace("samlSelfToken_initOnLoad():................End.\n");
}

function samlSelfToken_initParamsOnLoad()
{
    XmlDSigToolFormUtil.logTrace("samlSelfToken_initParamsOnLoad():................Start.\n");

    if ((window.arguments == null) || (window.arguments.length == 0)) {
    	return false;
    }

    gParams = window.arguments[0].QueryInterface(Components.interfaces.nsIDialogParamBlock);

    var paramCnt = gParams.GetInt(0);
    if (paramCnt <= 0) {
    	return false;
    }
    var unsignedXMLFilePath = gParams.GetString(0);
    var signedXMLFilePath = gParams.GetString(1);

    // xmldsigffext_doOnloadInitSignParam(unsignedXMLFilePath, signedXMLFilePath);

    XmlDSigToolFormUtil.logTrace("samlSelfToken_initParamsOnLoad():................End.\n");
    return true;
}


function samlSelfToken_onFinish(aWizardElem) 
{
}

function samlSelfToken_onCancel(aWizardElem) 
{
}

function samlSelfToken_setNextWizardPage(aNextPageId) 
{
    gSamlTokenWizardElem.currentPage.next = aNextPageId;
}

function samlTokenXmlDocFinishPageShow(aWizardPageElem) 
{
    XmlDSigToolFormUtil.logTrace("samlTokenXmlDocFinishPageShow():................Start.\n");

    gWizardButtonNextElem.label = gWizardButtonNextOrigLabel;

    gWizardButtonExtra1Elem.hidden = true;

    // XmlDSigToolFormUtil.logDebug("samlTokenXmlDocFinishPageShow(): aWizardPageElem.filepath: " + aWizardPageElem.filepath + "\n");
    // XmlDSigToolFormUtil.logDebug("samlTokenXmlDocFinishPageShow(): aWizardPageElem.xmldoc: " + aWizardPageElem.xmldoc + "\n");

    var finalXmlFilePathItemElem = document.getElementById("samltoken.form.xmldoc.finish.file.path");
    var finalXmlFilePathDataElem = document.getElementById("samltoken.form.xmldoc.finish.file.data");
    var finalXmlFilePathDataGboxElem = document.getElementById("samltoken.form.xmldoc.finish.file.data.gbox");

    if (!gSamlTokenWizardElem.generateOutFile) {
	finalXmlFilePathItemElem.hidden = true;
	// finalXmlFilePathDataGboxElem.hidden = true;
    	gSamlTokenWizardElem.canAdvance = true;
    	XmlDSigToolFormUtil.logTrace("samlTokenXmlDocFinishPageShow():................End(00).\n");
    	return true;
    }
    finalXmlFilePathItemElem.hidden = false;
    // finalXmlFilePathDataGboxElem.hidden = false;

    if (aWizardPageElem.xmldoc) {
    	finalXmlFilePathItemElem.xmldoc = aWizardPageElem.xmldoc;
    }
    if (aWizardPageElem.filepath) {
    	finalXmlFilePathItemElem.filepath = aWizardPageElem.filepath;
    }

    if (finalXmlFilePathItemElem.filepath) {
    	// finalXmlFilePathDataElem.value = finalXmlFilePathItemElem.readFile();
    	gSamlTokenWizardElem.canAdvance = true;
    	XmlDSigToolFormUtil.logTrace("samlTokenXmlDocFinishPageShow():................End(01).\n");
    	return true;
    }


    var finalOutXmlFilePickerElem = gSamlTokenWizardElem.finalOutXmlFilePickerElem;
    if (!finalOutXmlFilePickerElem.file) {
	var outXmlFile = null;
	// outXmlFile = finalOutXmlFilePickerElem.selectFile();
	if (!outXmlFile) {
	    outXmlFile = finalOutXmlFilePickerElem.autoSelectTempFile("XMLDSigTool", "OutXmlFile.xml");
	}
	finalXmlFilePathItemElem.file = outXmlFile;
    }
    if (!finalXmlFilePathItemElem.file || !aWizardPageElem.xmldoc) {
    	gSamlTokenWizardElem.canAdvance = false;
    	return false;
    }

    try {
    	var /*nsIFile*/ outXmlDocFile  = finalXmlFilePathItemElem.file;
    	// XmlDSigToolFormUtil.logDebug("xmlDocFinishPageShow(): outXmlDocFile: " + outXmlDocFile + "\n");
    	var sigEncXmlDSigTool = Components.classes["@avaya.com/pkm/xmldsigtool;1"].
    			getService(Components.interfaces.alrIXPXmlDSigTool);
    	// sigEncXmlDSigTool.saveXMLDocToFile(
    	finalXmlFilePathItemElem.saveXMLDocToFile(
			aWizardPageElem.xmldoc
			);
    	// finalXmlFilePathDataElem.value = finalXmlFilePathItemElem.readFile();
    } catch (ex) { 
    	gSamlTokenWizardElem.canAdvance = false;
    	return false;
    }

    gSamlTokenWizardElem.canAdvance = true;

    XmlDSigToolFormUtil.logTrace("samlTokenXmlDocFinishPageShow():................End.\n");
    return true;
}

function samlTokenXmlDocFinishPageAdvanced(aWizardPageElem) 
{
    // XmlDSigToolFormUtil.logTrace("samlTokenXmlDocFinishPageAdvanced():................Start.\n");

    // XmlDSigToolFormUtil.logTrace("samlTokenXmlDocFinishPageAdvanced():................End.\n");
    return true;
}

function samlTokenErrorPageShow(aWizardPageElem) 
{
    return true;
}

function handleExtra1CmdEvent(ev) 
{
    // XmlDSigToolFormUtil.logTrace("handleExtra1CmdEvent():................Start.\n");

    var buttonElem = ev.originalTarget;
    // XmlDSigToolFormUtil.logDebug("handleExtra1CmdEvent(): buttonElem: " + buttonElem + "\n");
    // XmlDSigToolFormUtil.logDebug("handleExtra1CmdEvent(): buttonElem: " + buttonElem + " label: " + buttonElem.label + "\n");
    var dlgtype = buttonElem.getAttribute("dlgtype");
    // XmlDSigToolFormUtil.logDebug("handleExtra1CmdEvent(): dlgtype: " + dlgtype + "\n");
    if (dlgtype != "extra1") {
    	return;
    }

    gSamlTokenWizardElem.canAdvance = true;
    gSamlTokenWizardElem.goTo("xmldsigffext.signenc.xmldoc.finish");
}

