/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is  Avaya Labs Research, Avaya Inc. Code.
 *
 * The Initial Developer of the Original Code is
 *   Subrata Mazumdar, Avaya Labs Research, Avaya Inc.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Subrata Mazumdar (mazum@avaya.com)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

if (typeof avxmldsig == 'undefined') {
    var avxmldsig = {};
}
if (typeof avxmldsig.dsigtool == 'undefined') {
    avxmldsig.dsigtool = {};
}

avxmldsig.dsigtool.PrefUtil = {
    logEnabled : true,
    log : function (msg) 
    {
	if (!avxmldsig.dsigtool.PrefUtil.logEnabled) {
	    return;
	}
	dump(msg + "\n");
    },
    getPrefType : function (prefId) 
    {
    	return avxmldsig.dsigtool.PrefUtil.mPrefRootBranch.getPrefType(prefId);
    },

    prefExists : function (prefId) 
    {
    	return (avxmldsig.dsigtool.PrefUtil.mPrefRootBranch.getPrefType(prefId) != avxmldsig.dsigtool.PrefUtil.mPrefRootBranch.PREF_INVALID);
    },

    getPreference : function (prefId, defval) 
    {
	var prefValue = null;
	if (typeof defval != 'undefined') {
	    prefValue = defval;
	}
	do {
	    try {
		/*
	    	var Prefs = Components.classes["@mozilla.org/preferences-service;1"]
				.getService(Components.interfaces.nsIPrefService);
		var prefBranchPrefixId = "";
		var prefsBranch = Prefs.getBranch(prefBranchPrefixId);
		if (!prefsBranch) {
		    break;
		}
		switch(aPrefValType) {
		    case "string" : 
		    	break;
		    case "bool" : 
		    	break;
		    case "int" : 
		    	break;
		    case "int" : 
		    	break;
		}
		*/
		var prefType = avxmldsig.dsigtool.PrefUtil.mPrefRootBranch.getPrefType(prefId);
		if (prefType == avxmldsig.dsigtool.PrefUtil.mPrefRootBranch.PREF_INVALID) {
		    break;
		}
		switch(prefType) {
		    case avxmldsig.dsigtool.PrefUtil.mPrefRootBranch.PREF_STRING : 
			var prefStringValue = avxmldsig.dsigtool.PrefUtil.mPrefRootBranch.getCharPref(prefId);
			// avxmldsig.dsigtool.PrefUtil.log("avxmldsig.dsigtool.PrefUtil.getPreference(): prefId: " + prefId + " prefStringValue: " + prefStringValue + " prefType: " + prefType + "");
			if (typeof prefStringValue != 'undefined') {
			    prefValue = prefStringValue;
			}
		    	break;
		    case avxmldsig.dsigtool.PrefUtil.mPrefRootBranch.PREF_BOOL : 
		        var prefBoolValue = avxmldsig.dsigtool.PrefUtil.mPrefRootBranch.getBoolPref(prefId);

			if (typeof prefBoolValue != 'undefined') {
			    prefValue = prefBoolValue;
			}
		    	break;
		    case avxmldsig.dsigtool.PrefUtil.mPrefRootBranch.PREF_INT : 
		        var prefIntValue = avxmldsig.dsigtool.PrefUtil.mPrefRootBranch.getIntPref(prefId);
			// avxmldsig.dsigtool.PrefUtil.log("avxmldsig.dsigtool.PrefUtil.getPreference(): prefId: " + prefId + " prefIntValue: " + prefIntValue + " prefType: " + prefType + "");
			if (typeof prefIntValue != 'undefined') {
			    prefValue = prefIntValue;
			}
		    	break;
		    default :
		    	break;
		}
	    } catch (ex) {
	    }
	} while (0);
	// avxmldsig.dsigtool.PrefUtil.log("avxmldsig.dsigtool.PrefUtil.getPreference(): prefId: " + prefId + " prefValue: " + prefValue + " prefType: " + prefType + "");

	return prefValue;
    },

    setPreference : function (prefId, prefValue) 
    {
	do {
	    try {
		/*
	    	var Prefs = Components.classes["@mozilla.org/preferences-service;1"]
			.getService(Components.interfaces.nsIPrefService);
		var prefBranchPrefixId = "";
		var prefsBranch = Prefs.getBranch(prefBranchPrefixId);
		if (!prefsBranch) {
		    break;
		}
		*/

		var valType = typeof(prefValue); 
		var prefValType = avxmldsig.dsigtool.PrefUtil.mPrefRootBranch.PREF_INVALID; 
		switch(valType) {
		    case "string" : 
			prefValType = avxmldsig.dsigtool.PrefUtil.mPrefRootBranch.PREF_STRING;
		    	break;
		    case "boolean" : 
			prefValType = avxmldsig.dsigtool.PrefUtil.mPrefRootBranch.PREF_BOOL;
		    	break;
		    case "number" : 
			prefValType = avxmldsig.dsigtool.PrefUtil.mPrefRootBranch.PREF_INT;
		    	break;
		    default :
		    	break;
		}
		if (prefValType == avxmldsig.dsigtool.PrefUtil.mPrefRootBranch.PREF_INVALID) {
		    break;
		}

		var prefType = avxmldsig.dsigtool.PrefUtil.mPrefRootBranch.getPrefType(prefId);
		// avxmldsig.dsigtool.PrefUtil.log("avxmldsig.dsigtool.PrefUtil.setPreference(): prefId: " + prefId + " valType: " + valType + " prefValType: " + prefValType + " prefType: " + prefType + "");
		if (prefType == avxmldsig.dsigtool.PrefUtil.mPrefRootBranch.PREF_INVALID) {
		    prefType = prefValType;
		}
		if (prefType != prefValType) {
		    break;
		}

		switch(prefType) {
		    case avxmldsig.dsigtool.PrefUtil.mPrefRootBranch.PREF_STRING : 
			var prefStringValue = prefValue;
		        avxmldsig.dsigtool.PrefUtil.mPrefRootBranch.setCharPref(prefId, prefStringValue);
		    	break;
		    case avxmldsig.dsigtool.PrefUtil.mPrefRootBranch.PREF_BOOL : 
			var prefBoolValue = prefValue;
			/*
			var prefBoolValue = true;
			if (!prefValue || (prefValue != "true")) {
			    prefBoolValue = false;
			}
			*/
		        avxmldsig.dsigtool.PrefUtil.mPrefRootBranch.setBoolPref(prefId, prefBoolValue);
		    	break;
		    case avxmldsig.dsigtool.PrefUtil.mPrefRootBranch.PREF_INT : 
			var prefIntValue = prefValue;
		        avxmldsig.dsigtool.PrefUtil.mPrefRootBranch.setIntPref(prefId, prefIntValue);
		    	break;
		    default :
		    	break;
		}
	    } catch (ex) {
	    }
	} while (0);
    },

    copyPreference : function (fromPrefId, toPrefId) 
    {
	var fromPrefExists = avxmldsig.dsigtool.PrefUtil.prefExists(fromPrefId);
	if (!fromPrefExists) {
    	    avxmldsig.dsigtool.PrefUtil.resetPreference(toPrefId);
	    return;
	}

    	var fromPrefValue = avxmldsig.dsigtool.PrefUtil.getPreference(fromPrefId);
	avxmldsig.dsigtool.PrefUtil.log("avxmldsig.dsigtool.PrefUtil.copyPreference(): fromPrefId: " + fromPrefId + " fromPrefValue: " + fromPrefValue + "valType: " + typeof(fromPrefValue) + "");

    	avxmldsig.dsigtool.PrefUtil.setPreference(toPrefId, fromPrefValue);
    },

    resetPreference : function (prefId) 
    {
	do {
	    try {
		/*
	        var Prefs = Components.classes["@mozilla.org/preferences-service;1"]
			.getService(Components.interfaces.nsIPrefService);
		var prefBranchPrefixId = "";
		var prefsBranch = Prefs.getBranch(prefBranchPrefixId);
		if (!prefsBranch) {
		    break;
		}
		*/
		avxmldsig.dsigtool.PrefUtil.mPrefRootBranch.clearUserPref(prefId);
	    } catch (ex) {
	    }
	} while (0);
    },

    deletePreference : function (prefId) 
    {
    	avxmldsig.dsigtool.PrefUtil.mPrefRootBranch.deleteBranch(prefId);
    },

    init : function () 
    {
	avxmldsig.dsigtool.PrefUtil.mPrefService = Components.classes["@mozilla.org/preferences-service;1"]
						.getService(Components.interfaces.nsIPrefService);
	avxmldsig.dsigtool.PrefUtil.mPrefRootBranch = avxmldsig.dsigtool.PrefUtil.mPrefService.getBranch("");
    },

    uninit : function () 
    {
	avxmldsig.dsigtool.PrefUtil.mPrefService = null;
	avxmldsig.dsigtool.PrefUtil.mPrefRootBranch = null;
    }
};

