/* @(#) $Id: XmlDSigEncWizard.js,v 1.15 2012/10/03 23:08:12 subrata Exp $ */

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is  Avaya Labs Research, Avaya Inc. Code.
 *
 * The Initial Developer of the Original Code is
 *     Subrata Mazumdar, Avaya Labs Research, Avaya Inc.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Subrata Mazumdar (mazum@avaya.com)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */



var gParams = null;
var gPkiParams = null;

var gXmlDocWizardInitDone = false;
var gXmlDocWizardElem;

var gWizardButtonNextElem;
var gWizardButtonFinishElem;
var gWizardButtonExtra1Elem;
/*
var gWizardButtonBackElem;
var gWizardButtonExtra2Elem;
var gWizardButtonCancelElem;
*/
var gWizardButtonNextOrigLabel;

var XmlDSigEncWizard = {
    mMaxLogLevel		: 2,
    log : function(level, msg)
    {
	if (level > XmlDSigEncWizard.mMaxLogLevel) {
            return;
        }
        dump(msg + "");
    },

    dump : function(msg)
    {
        XmlDSigEncWizard.log(1, msg);
    },
    logError : function(msg)
    {
        XmlDSigEncWizard.log(2, msg);
    },
    logTrace : function(msg)
    {
        XmlDSigEncWizard.log(4, msg);
    },
    logDebug : function(msg)
    {
        XmlDSigEncWizard.log(8, msg);
    },
    lastMethod : function () 
    {
    }
};


function xmldsigffext_SigEncWizard_initOnLoad()
{

    if (gXmlDocWizardInitDone) {
    	return;
    }

    XmlDSigEncWizard.logTrace("xmldsigffext_SigEncWizard_initOnLoad():................Start.");
    gXmlDocWizardInitDone = true;

    xmldsigffext_isSupportedOS();


    gXmlDocWizardElem = document.getElementById('xmldsigffext.signenc.wizard');
    gWizardButtonNextElem = gXmlDocWizardElem.getButton("next");
    gWizardButtonNextOrigLabel = gWizardButtonNextElem.label;

    gWizardButtonFinishElem = gXmlDocWizardElem.getButton("finish");

    gWizardButtonExtra1Elem = gXmlDocWizardElem.getButton("extra1");
    gWizardButtonExtra1Elem.label = gWizardButtonFinishElem.label;
    gWizardButtonExtra1Elem.addEventListener('command', handleExtra1CmdEvent, false);

    // xmldsigffext_SigEncWorkFlow_initOnLoad(gXmlDocWizardElem);

    xmldsigffext_SigEncOverlay_initOnLoad(gXmlDocWizardElem);

    /**********************************************/
    /* TODO:  TEST CODE - remove after test phase */
    /**********************************************/
    var testMode = avxmldsig.dsigtool.PrefUtil.getPreference("xmldsigffext.test", false);
    if (testMode) {
    try {
        var tokenPassword = "abcd1234";
        var tokendb = Components.classes["@mozilla.org/security/pk11tokendb;1"].
                            getService(Components.interfaces.nsIPK11TokenDB);
        var token = tokendb.getInternalKeyToken();
        if (token) {
            token.checkPassword(tokenPassword);
            token.login(false);
        }
    } catch (ex) {}
    }

    XmlDSigEncWizard.logTrace("xmldsigffext_SigEncWizard_initOnLoad():................End.");
}

function xmldsigffext_doOnloadInitSignParam(
	/* String */ inXmlFilePath,
	/* String */ aOutXmlFilePath,
	/* String */ aWizardCommandSteps,
	/* nsIX509 */ aSelectedSignerCert,
	/* String */ aSignatureType,
	/* String */ aCanonicalizationMethodName,
	/* String */ aSignatureMethod
	)
{
    XmlDSigEncWizard.logTrace("xmldsigffext_doOnloadInitSignParam():................Start.");
    // xmldsigffext_initVerifyFormXULElems();

    XmlDSigEncWizard.logDebug("inXmlFilePath: " + inXmlFilePath + " " + 
    		"aOutXmlFilePath: " + aOutXmlFilePath + " " + 
    		"aWizardCommandSteps: " + aWizardCommandSteps + " " + 
    		"cert: " + (aSelectedSignerCert?aSelectedSignerCert.nickname:"") + " " + 
    		"aSignatureType: " + aSignatureType + " " + 
    		"aCanonicalizationMethodName: " + aCanonicalizationMethodName + " " + 
    		"aSignatureMethod: " + aSignatureMethod + " " + 
		"");

    var xmlDocSaveInFileElem = document.getElementById('xmldsigffext.signenc.xmldoc.workflow.save');
    handleSaveWizardPageOutputChange(xmlDocSaveInFileElem);

    if (inXmlFilePath) {
	gXmlDocWizardElem.inXmlFilePath = inXmlFilePath;
    }

    if (aWizardCommandSteps) {
    	activateCustomWizardPages(aWizardCommandSteps);
    }

    if (aOutXmlFilePath && (aOutXmlFilePath != "")) {
	gXmlDocWizardElem.outXmlFilePath = aOutXmlFilePath;
    	var finalOutXmlFilePickerRowElem = document.getElementById("xmldsigffext.signenc.xmldoc.workflow.out.file.row");
	// finalOutXmlFilePickerRowElem.hidden = true;
    	var finalOutXmlFilePickerElem = document.getElementById("xmldsigffext.signenc.xmldoc.workflow.out.file");
	finalOutXmlFilePickerElem.filepath = aOutXmlFilePath;
	if (finalOutXmlFilePickerElem.file) {
	    finalOutXmlFilePickerElem.disabled = true;
	}
    }

    xmldsigffext_SignEnc_doOnloadInitSignCertParam(
		aSelectedSignerCert,
		aSignatureType,
		aCanonicalizationMethodName,
		aSignatureMethod
    		);
    
    XmlDSigEncWizard.logTrace("xmldsigffext_doOnloadInitSignParam():................End.");
}

function xmldsigffext_initParamsOnLoad()
{
    XmlDSigEncWizard.logTrace("xmldsigffext_initParamsOnLoad():................Start.");

    if (!window.arguments == null || (window.arguments.length == 0) || !window.arguments[0]) {
    	// xmldsigffext_testParamsOnLoad();
    	return false;
    }

    try {
    	gParams = window.arguments[0].QueryInterface(Components.interfaces.nsIDialogParamBlock);
    	gPkiParams = window.arguments[0].QueryInterface(Components.interfaces.nsIPKIParamBlock);
    } catch (ex) {}

    if (!gParams) {
    	return false;
    }

    var paramCnt = gParams.GetInt(0);
    if (paramCnt <= 0) {
    	return false;
    }

    //
    // Parameters are position based (like command line) 
    // in the following order: command-steps, inXMLFile, outXMLFile, signatureType,
    //                         canonicalizationMethodName, signatureMethod.
    // You cannot omit intermediate paramters - "" (zero-length string) in those cases.
    //
    
    var argc = 0;
    var wizardWorkFlowSeq	= gParams.GetString(argc); argc++;
    var unsignedXMLFilePath	= gParams.GetString(argc); argc++;
    var signedXMLFilePath	= gParams.GetString(argc); argc++;


    var signatureType		= gParams.GetString(argc); argc++;
    if (signatureType == "") {
    	signatureType = null;
    }

    var canonicalizationMethodName = gParams.GetString(argc); argc++;
    if (canonicalizationMethodName == "") {
    	canonicalizationMethodName = null;
    }

    var signatureMethod = gParams.GetString(argc); argc++;
    if (signatureMethod == "") {
    	signatureMethod = null;
    }

    var signerX509Cert = null;
    if (gPkiParams) {
    	signerX509Cert = gPkiParams.getISupportAtIndex(1); argc++;
        if (signerX509Cert) {
    	    signerX509Cert = signerX509Cert.QueryInterface(Components.interfaces.nsIX509Cert);
        }
    }

    xmldsigffext_doOnloadInitSignParam(
    		unsignedXMLFilePath,
		signedXMLFilePath,
		wizardWorkFlowSeq,
		signerX509Cert,
		signatureType,
		canonicalizationMethodName
		);

    XmlDSigEncWizard.logTrace("xmldsigffext_initParamsOnLoad():................End.");
    return true;
}

function xmldsigffext_testParamsOnLoad()
{
    XmlDSigEncWizard.logTrace("xmldsigffext_testParamsOnLoad():................Start.");

    var wizardWorkFlowSeq	= avxmldsig.dsigtool.PrefUtil.getPreference("extensions.avxmldsig.sign.wizardWorkFlowSeq");
    var inputXMLFilePath	= avxmldsig.dsigtool.PrefUtil.getPreference("extensions.avxmldsig.sign.inputXMLFilePath");
    var outputXMLFilePath	= avxmldsig.dsigtool.PrefUtil.getPreference("extensions.avxmldsig.sign.outputXMLFilePath");

    var credentialType		= avxmldsig.dsigtool.PrefUtil.getPreference("extensions.avxmldsig.sign.credentialType");
    var signatureType		= avxmldsig.dsigtool.PrefUtil.getPreference("extensions.avxmldsig.sign.signatureType");
    var canonicalizationMethodName = avxmldsig.dsigtool.PrefUtil.getPreference("extensions.avxmldsig.sign.canonicalizationMethodName");
    var signatureMethod		= avxmldsig.dsigtool.PrefUtil.getPreference("extensions.avxmldsig.sign.signatureMethod");
    var signerX509CertNickName	= avxmldsig.dsigtool.PrefUtil.getPreference("extensions.avxmldsig.sign.signerX509CertNickName");
    var signerX509Cert		= null;

    if (signerX509CertNickName && (signerX509CertNickName != "")) {
    	var x509CertDB = Components.classes["@mozilla.org/security/x509certdb;1"].
				getService(Components.interfaces.nsIX509CertDB);
    	try {
    	    signerX509Cert = x509CertDB.findCertByNickname(null, signerX509CertNickName);
    	} catch (ex) { signerX509Cert = null; }
    }


    xmldsigffext_doOnloadInitSignParam(
    		inputXMLFilePath,
		outputXMLFilePath,
		wizardWorkFlowSeq,
		signerX509Cert,
		signatureType,
		canonicalizationMethodName,
		signatureMethod
		);

    XmlDSigEncWizard.logTrace("xmldsigffext_testParamsOnLoad():................End.");
    return true;
}

function xmldsigffext_onFinish(aWizardElem) 
{
}

function xmldsigffext_onCancel(aWizardElem) 
{
}

function handleExtra1CmdEvent(ev) 
{
    XmlDSigEncWizard.logTrace("handleExtra1CmdEvent():................Start.");

    var buttonElem = ev.originalTarget;
    XmlDSigEncWizard.logDebug("handleExtra1CmdEvent(): buttonElem: " + buttonElem + "");
    XmlDSigEncWizard.logDebug("handleExtra1CmdEvent(): buttonElem: " + buttonElem + " label: " + buttonElem.label + "");
    var dlgtype = buttonElem.getAttribute("dlgtype");
    XmlDSigEncWizard.logDebug("handleExtra1CmdEvent(): dlgtype: " + dlgtype + "");
    if (dlgtype != "extra1") {
    	return;
    }

    gXmlDocWizardElem.canAdvance = true;
    gXmlDocWizardElem.goTo("xmldsigffext.signenc.xmldoc.finish");
}


function xmlDocFinishPageShow(aWizardPageElem) 
{
    XmlDSigEncWizard.logTrace("xmlDocFinishPageShow():................Start.");
    // XmlDSigEncWizard.logDebug("xmlDocFinishPageShow(): aWizardPageElem.filepath: " + aWizardPageElem.filepath + "");
    // XmlDSigEncWizard.logDebug("xmlDocFinishPageShow(): aWizardPageElem.xmldoc: " + aWizardPageElem.xmldoc + "");

    gWizardButtonNextElem.label = gWizardButtonNextOrigLabel;
    gWizardButtonExtra1Elem.hidden = true;

    gXmlDocWizardElem.canAdvance = false;

    var finalXmlFilePathItemElem = document.getElementById("xmldsigffext.signenc.xmldoc.finish.file.path");
    var finalXmlFilePathDataElem = document.getElementById("xmldsigffext.signenc.xmldoc.finish.file.data");
    var finalXmlFilePathDataGBoxElem = document.getElementById("xmldsigffext.signenc.xmldoc.finish.file.data.gbox");
    finalXmlFilePathDataGBoxElem.hidden = true;

    if (!gXmlDocWizardElem.generateOutFile) {
	finalXmlFilePathItemElem.hidden = true;
	// finalXmlFilePathDataGBoxElem.hidden = true;
    	gXmlDocWizardElem.canAdvance = true;
    	XmlDSigEncWizard.logTrace("xmlDocFinishPageShow():................End(00).");
    	return true;
    }
    finalXmlFilePathItemElem.hidden = false;
    // finalXmlFilePathDataGBoxElem.hidden = false;

    if (aWizardPageElem.xmldoc) {
    	finalXmlFilePathItemElem.xmldoc = aWizardPageElem.xmldoc;
    }
    if (aWizardPageElem.filepath) {
    	finalXmlFilePathItemElem.filepath = aWizardPageElem.filepath;
    }

    if (finalXmlFilePathItemElem.filepath) {
    	gXmlDocWizardElem.canAdvance = true;
    	XmlDSigEncWizard.logTrace("xmlDocFinishPageShow():................End(01).");
    	return true;
    }


    var finalOutXmlFilePickerElem = gXmlDocWizardElem.finalOutXmlFilePickerElem;
    if (!finalOutXmlFilePickerElem.file) {
	var outXmlFile = null;
	// outXmlFile = finalOutXmlFilePickerElem.selectFile();
	if (!outXmlFile) {
	    outXmlFile = finalOutXmlFilePickerElem.autoSelectTempFile("XMLDSigTool", "OutXmlFile.xml");
	}
	finalXmlFilePathItemElem.file = outXmlFile;
    }
    if (!finalXmlFilePathItemElem.file || !aWizardPageElem.xmldoc) {
    	gXmlDocWizardElem.canAdvance = false;
    	XmlDSigEncWizard.logTrace("xmlDocFinishPageShow():................End(02).");
    	return false;
    }
    XmlDSigEncWizard.logDebug("xmlDocFinishPageShow():finalXmlFilePathItemElem.filepath: " + finalXmlFilePathItemElem.filepath + "");
    try {
    	finalXmlFilePathItemElem.saveXMLDocToFile(
			aWizardPageElem.xmldoc
			);
    } catch (ex) { 
    	gXmlDocWizardElem.canAdvance = false;
    	XmlDSigEncWizard.logError("xmlDocFinishPageShow(): finalXmlFilePathItemElem.saveXMLDocToFile() failed - ex: " + ex + "");
    	return false;
    }

    gXmlDocWizardElem.canAdvance = true;

    XmlDSigEncWizard.logTrace("xmlDocFinishPageShow():................End.");
    return true;
}

function xmlDocFinishPageAdvanced(aWizardPageElem) 
{
    return true;
}

function xmlDocErrorPageShow(aWizardPageElem) 
{
    return true;
}

