/* @(#) $Id: XmlDSigEncWizardOverlay.js,v 1.13 2012/10/03 23:08:12 subrata Exp $ */

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is  Avaya Labs Research, Avaya Inc. Code.
 *
 * The Initial Developer of the Original Code is
 *     Subrata Mazumdar, Avaya Labs Research, Avaya Inc.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Subrata Mazumdar (mazum@avaya.com)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


var XmlDSigEncWizardOverlay = {
    mMaxLogLevel		: 2,
    log : function(level, msg)
    {
	if (level > XmlDSigEncWizardOverlay.mMaxLogLevel) {
            return;
        }
        dump(msg + "");
    },

    dump : function(msg)
    {
        XmlDSigEncWizardOverlay.log(1, msg);
    },
    logError : function(msg)
    {
        XmlDSigEncWizardOverlay.log(2, msg);
    },
    logTrace : function(msg)
    {
        XmlDSigEncWizardOverlay.log(4, msg);
    },
    logDebug : function(msg)
    {
        XmlDSigEncWizardOverlay.log(8, msg);
    },
    lastMethod : function () 
    {
    }
};


var /* nsIX509CertDB	  */ gSigEncCertDB = null;
var /* nsIX509CertDB	  */ gSigEncX509CertDBUtil = null;
var /* alrIXPXmlDSigTool  */ gSigEncXmlDSigTool = null;
var /* alrIXPXmlEncSvc	  */ gSigEncXmlEncSvc = null;

var gXmlDocSignEncWizardElem;

var gSigEncWizardInitDone = false;
var gSigEncWizardButtonNextElem;
var gSigEncWizardButtonNextOrigLabel;

function xmldsigffext_SigEncOverlay_initOnLoad(aWizardElem)
{
    XmlDSigEncWizardOverlay.logTrace("xmldsigffext_SigEncOverlay_initOnLoad():................Start.");
    if (gSigEncWizardInitDone) {
    	return;
    }
    gSigEncWizardInitDone = true;

    gXmlDocSignEncWizardElem = aWizardElem;
    gSigEncWizardButtonNextElem = gXmlDocSignEncWizardElem.getButton("next");
    gSigEncWizardButtonNextOrigLabel = gSigEncWizardButtonNextElem.label;


    initXmlDocSignEncHandler();
    initDefaultXmlDocSigParam();
    initDefaultXmlDocEncryptParam();

    XmlDSigEncWizardOverlay.logTrace("xmldsigffext_SigEncOverlay_initOnLoad():................End.");
}

function initXmlDocSignEncHandler()
{
    const  XPILoadErrorMessage = "Make sure that DLLs (shared libraries) from Apache Xerces-C++ and Xalan-C++ are in your PATH (LD_LIBRARY_PATH) environment variable.";

    try {
    	gSigEncCertDB = Components.classes["@mozilla.org/security/x509certdb;1"].
			getService(Components.interfaces.nsIX509CertDB);
    	gSigEncX509CertDBUtil = Components.classes["@avaya.com/pkm/x509certdbutil;1"].
    			getService(Components.interfaces.alrIX509CertDBUtil);
    	gSigEncXmlDSigTool = Components.classes["@avaya.com/pkm/xmldsigtool;1"].
    			getService(Components.interfaces.alrIXPXmlDSigTool);
    	gSigEncXmlEncSvc = Components.classes["@avaya.com/pkm/xmlencsvc;1"].
    			getService(Components.interfaces.alrIXPXmlEncSvc);

    } catch (ex) {
    	alert("xmldsigffext_initSignFormXULElems(): failed to create instance of alrIXPXmlDSigTool - ex: " + ex + "");
    	XmlDSigEncWizardOverlay.logError("xmldsigffext_initSignFormXULElems(): failed to create instance of alrIXPXmlDSigTool - ex: " + ex + "");
	XmlDSigEncWizardOverlay.logError(XPILoadErrorMessage + "");
	throw ex;
    }
    if (gSigEncXmlDSigTool == null) {
    	alert("xmldsigffext_initSignFormXULElems(): failed to create instance of alrIXPXmlDSigTool.");
    	XmlDSigEncWizardOverlay.logError("xmldsigffext_initSignFormXULElems(): failed to create instance of alrIXPXmlDSigTool.");
	XmlDSigEncWizardOverlay.logError(XPILoadErrorMessage + "");
    	return;
    }
}


function xmldsigffext_SignEnc_doOnloadInitSignParam(
	/* nsIX509 */ aSelectedSignerCert,
	/* String */ aSignerUserName,
	/* String */ aSignerSharedKey,
	/* String */ aCredentialType,
	/* String */ aSignatureType,
	/* String */ aCanonicalizationMethodName,
	/* String */ aSignatureMethod,
	/* String */ aSigKeyInfoParam
	)
{
    XmlDSigEncWizardOverlay.logTrace("xmldsigffext_SignEnc_doOnloadInitSignParam():................Start.");
    // xmldsigffext_initVerifyFormXULElems();

    /*
    XmlDSigEncWizardOverlay.logDebug("xmldsigffext_SignEnc_doOnloadInitSignParam():\n" + 
    		"aSignatureType: " + aSignatureType + "\n\t" + 
    		"aCanonicalizationMethodName: " + aCanonicalizationMethodName + "\n\t" + 
    		"aCredentialType: " + aCredentialType + "\n\t" + 
    		" cert: " + (aSelectedSignerCert?aSelectedSignerCert.nickname:"") + "\n\t" + 
    		"aSignerUserName: " + aSignerUserName + "\n\t" + 
    		"aSignerSharedKey: " + aSignerSharedKey + "\n\t" + 
    		"aSignatureMethod: " + aSignatureMethod + "\n\t" + 
    		"aSigKeyInfoParam: " + aSigKeyInfoParam + "\n\t" + 
		""
		);
    */

    var xmlDocSignDSigBoxElem = document.getElementById("xmldsigffext.signenc.xmldoc.sign.xmldsig");

    // Signature type initialization must be the first one.
    // Otherwise, already set parameters will be reinitialized to default value.
    if (aSignatureType) {
    	xmlDocSignDSigBoxElem.signatureType = aSignatureType;
    }

    if (aCanonicalizationMethodName) {
    	xmlDocSignDSigBoxElem.canonicalizationMethodName = aCanonicalizationMethodName;
    }

    if (aSigKeyInfoParam) {
	var keyInfoParamOptions = parseInt(aSigKeyInfoParam);
    	xmlDocSignDSigBoxElem.keyInfoParamOptions = keyInfoParamOptions;
    }

    var credentialType = aCredentialType;
    if (!aCredentialType) {
        if (aSelectedSignerCert) {
    	    credentialType = "certificate";
        }
	else {
    	    credentialType = "password";
	}
    }

    var signatureMethod = aSignatureMethod;
    if (signatureMethod) {
	if (credentialType == "password") {
            if (signatureMethod.indexOf("#hmac-sha") <= 0) {
    	        signatureMethod = "http://www.w3.org/2000/09/xmldsig#hmac-sha1";
            }
	}
	else {
            if (signatureMethod.indexOf("#hmac-sha") > 0) {
    	        signatureMethod = "http://www.w3.org/2000/09/xmldsig#rsa-sha1";
	    }
	}
    }
    else {
	if (credentialType == "password") {
    	    signatureMethod = "http://www.w3.org/2000/09/xmldsig#hmac-sha1";
	}
    }

    if (signatureMethod) {
    	xmlDocSignDSigBoxElem.signatureMethod = signatureMethod;
    }
    xmlDocSignDSigBoxElem.credentialType = credentialType;

    if (xmlDocSignDSigBoxElem.credentialType == "password") {
	if (aSignerUserName) {
    	    xmlDocSignDSigBoxElem.signerUserName = aSignerUserName;
	}
	if (aSignerSharedKey) {
    	    xmlDocSignDSigBoxElem.signerSharedKey = aSignerSharedKey;
	}
    }
    else {
	if (aSelectedSignerCert) {
	    xmlDocSignDSigBoxElem.signerCert = aSelectedSignerCert;
	}
    }

    /*
    XmlDSigEncWizardOverlay.logDebug("xmldsigffext_SignEnc_doOnloadInitSignParam(): xmlDocSignDSigBoxElem: \n" + 
    		"signatureType: " + xmlDocSignDSigBoxElem.signatureType + "\n\t" + 
    		"canonicalizationMethodName: " + xmlDocSignDSigBoxElem.canonicalizationMethodName + "\n\t" + 
    		"credentialType: " + xmlDocSignDSigBoxElem.credentialType + "\n\t" + 
    		"cert: " + (xmlDocSignDSigBoxElem.signerCert?xmlDocSignDSigBoxElem.signerCert.nickname:"") + "\n\t" + 
    		"signerUserName: " + xmlDocSignDSigBoxElem.signerUserName + "\n\t" + 
    		"signerSharedKey: " + xmlDocSignDSigBoxElem.signerSharedKey + "\n\t" + 
    		"signatureMethod: " + xmlDocSignDSigBoxElem.signatureMethod + "\n\t" + 
    		"keyInfoParamOptions: " + xmlDocSignDSigBoxElem.keyInfoParamOptions + " " + 
		""
		);
    */

    XmlDSigEncWizardOverlay.logTrace("xmldsigffext_SignEnc_doOnloadInitSignParam():................End.");
}

function xmldsigffext_SignEnc_doOnloadInitSignSymKeyParam(
	/* String */ aSignerUserName,
	/* String */ aSignerSharedKey,
	/* String */ aSignatureType,
	/* String */ aCanonicalizationMethodName,
	/* String */ aSignatureMethod,
	/* String */ aSigKeyInfoParam
	)
{
    var credentialType = "password";
    var signatureMethod = aSignatureMethod;
    if (!signatureMethod || signatureMethod.indexOf("#hmac-sha") <= 0) {
    	signatureMethod = "http://www.w3.org/2000/09/xmldsig#hmac-sha1";
    }
    xmldsigffext_SignEnc_doOnloadInitSignParam(
		null,
		aSignerUserName,
		aSignerSharedKey,
		credentialType,
		aSignatureType,
    		aCanonicalizationMethodName,
		signatureMethod,
		aSigKeyInfoParam
		);
}

function xmldsigffext_SignEnc_doOnloadInitSignCertParam(
	/* nsIX509 */ aSelectedSignerCert,
	/* String */ aSignatureType,
	/* String */ aCanonicalizationMethodName,
	/* String */ aSignatureMethod,
	/* String */ aSigKeyInfoParam
	)
{
    XmlDSigEncWizardOverlay.logTrace("xmldsigffext_SignEnc_doOnloadInitSignCertParam():................Start.");

    var credentialType = "certificate";

    var signatureMethod = aSignatureMethod;
    if (!signatureMethod || signatureMethod.indexOf("#hmac-sha") > 0) {
    	signatureMethod = "http://www.w3.org/2000/09/xmldsig#rsa-sha1";
    }
    xmldsigffext_SignEnc_doOnloadInitSignParam(
		aSelectedSignerCert,
		null,
		null,
		credentialType,
		aSignatureType,
    		aCanonicalizationMethodName,
		signatureMethod,
		aSigKeyInfoParam
		);

    XmlDSigEncWizardOverlay.logTrace("xmldsigffext_SignEnc_doOnloadInitSignCertParam():................End.");
}


function initDefaultXmlDocSigParam()
{
    XmlDSigEncWizardOverlay.logTrace("initDefaultXmlDocSigParam():................Start.");

    // TODO: Obtain these parameters from preferences

    /*
    var xmlDocSignDSigBoxElem = document.getElementById("xmldsigffext.signenc.xmldoc.sign.xmldsig");
    xmlDocSignDSigBoxElem.signatureType = "ENVELOPED_SIGNATURE";
    xmlDocSignDSigBoxElem.credentialType = "certificate";
    xmlDocSignDSigBoxElem.canonicalizationMethodName = "C14NE_NOC";
    xmlDocSignDSigBoxElem.signatureMethod = "http://www.w3.org/2000/09/xmldsig#rsa-sha1";
    */

    var signerX509CertNickName	= avxmldsig.dsigtool.PrefUtil.getPreference("extensions.avxmldsig.sign.signerX509CertNickName");
    var signatureType		= avxmldsig.dsigtool.PrefUtil.getPreference("extensions.avxmldsig.sign.signatureType", "ENVELOPED_SIGNATURE");
    var credentialType		= avxmldsig.dsigtool.PrefUtil.getPreference("extensions.avxmldsig.sign.credentialType", "certificate");
    var canonicalizationMethodName = avxmldsig.dsigtool.PrefUtil.getPreference("extensions.avxmldsig.sign.canonicalizationMethodName", "C14NE_NOC");
    var certSignatureMethod	= avxmldsig.dsigtool.PrefUtil.getPreference("extensions.avxmldsig.sign.signatureMethod", "http://www.w3.org/2000/09/xmldsig#rsa-sha1");
    var symKeySignatureMethod	= avxmldsig.dsigtool.PrefUtil.getPreference("extensions.avxmldsig.sign.signatureMethod.symkey");
    var signatureMethod = null; 
    if (credentialType == "certificate") {
    	signatureMethod = certSignatureMethod;
    }
    else {
    	signatureMethod = symKeySignatureMethod;
    }

    /*
    if (!signatureType) {
    	signatureType = "ENVELOPED_SIGNATURE";
    }

    if (!canonicalizationMethodName) {
    	canonicalizationMethodName = "C14NE_NOC";
    }

    if (!credentialType) {
    	credentialType = "certificate";
    }
    if (!signatureMethod) {
    	signatureMethod = "http://www.w3.org/2000/09/xmldsig#rsa-sha1";
    }
    */


    var signerX509Cert = null;
    if (signerX509CertNickName && (signerX509CertNickName != "") 
    				&& (credentialType == "certificate")) {
    	var x509CertDB = Components.classes["@mozilla.org/security/x509certdb;1"].
				getService(Components.interfaces.nsIX509CertDB);
    	try {
    	    signerX509Cert = x509CertDB.findCertByNickname(null, signerX509CertNickName);
    	} catch (ex) { signerX509Cert = null; }
	/*
        if (signerX509Cert) {
	    xmlDocSignDSigBoxElem.signerCert = signerX509Cert;
        }
	*/
    }

    if (credentialType == "certificate") {
    	xmldsigffext_SignEnc_doOnloadInitSignCertParam(
		signerX509Cert,
		signatureType,
		canonicalizationMethodName,
		signatureMethod
		);
    }
    else {
    	xmldsigffext_SignEnc_doOnloadInitSignSymKeyParam(
		null, null,
		signatureType,
		canonicalizationMethodName,
		signatureMethod
		);
    }

    XmlDSigEncWizardOverlay.logTrace("initDefaultXmlDocSigParam():................End.");
}


function xmldsigffext_SignEnc_testParamsOnLoad()
{
    XmlDSigEncWizardOverlay.logTrace("xmldsigffext_SignEnc_testParamsOnLoad():................Start.");

    var credentialType		= avxmldsig.dsigtool.PrefUtil.getPreference("extensions.avxmldsig.sign.credentialType");
    var signatureType		= avxmldsig.dsigtool.PrefUtil.getPreference("extensions.avxmldsig.sign.signatureType");
    var canonicalizationMethodName = avxmldsig.dsigtool.PrefUtil.getPreference("extensions.avxmldsig.sign.canonicalizationMethodName");
    var signatureMethod		= avxmldsig.dsigtool.PrefUtil.getPreference("extensions.avxmldsig.sign.signatureMethod");
    var signerX509CertNickName	= avxmldsig.dsigtool.PrefUtil.getPreference("extensions.avxmldsig.sign.signerX509CertNickName");
    var signerX509Cert		= null;

    if (signerX509CertNickName && (signerX509CertNickName != "")) {
    	var x509CertDB = Components.classes["@mozilla.org/security/x509certdb;1"].
				getService(Components.interfaces.nsIX509CertDB);
    	try {
    	    signerX509Cert = x509CertDB.findCertByNickname(null, signerX509CertNickName);
    	} catch (ex) { signerX509Cert = null; }
    }


    xmldsigffext_SignEnc_doOnloadInitSignCertParam(
		signerX509Cert,
		signatureType,
		canonicalizationMethodName,
		signatureMethod
		);

    XmlDSigEncWizardOverlay.logTrace("xmldsigffext_SignEnc_testParamsOnLoad():................End.");
    return true;
}



function xmldsigffext_SignEnc_xmlDocParseXmlFile(aXmlDocInFilePicker)
{
    XmlDSigEncWizardOverlay.logTrace("xmldsigffext_SignEnc_xmlDocParseXmlFile():................Start.");

    var unsignedXmlFile = aXmlDocInFilePicker.file;
    if (unsignedXmlFile == null) {
    	// alert("xmldsigffext_SignEnc_xmlDocParseXmlFile(): signed XML file name is missing.");
    	XmlDSigEncWizardOverlay.logError("xmldsigffext_SignEnc_xmlDocParseXmlFile(): signed XML file name is missing.");
    	return null;
    }
    if (unsignedXmlFile.fileSize == 0) {
    	alert("xmldsigffext_SignEnc_xmlDocParseXmlFile(): Zero-length XML file - pick another one.");
    	XmlDSigEncWizardOverlay.logError("xmldsigffext_SignEnc_xmlDocParseXmlFile(): Zero-length XML file - pick another one.");
    	return null;
    }

    var /* nsIDOMDocument */ unsignedXmlDoc = gSigEncXmlDSigTool.readXMLDocFromFile(unsignedXmlFile);
    if (!unsignedXmlDoc) {
    	alert("xmldsigffext_SignEnc_xmlDocParseXmlFile(): Not a valid XML file.");
    	XmlDSigEncWizardOverlay.logError("xmldsigffext_SignEnc_xmlDocParseXmlFile(): Not a valid XML file.");
    	return null;
    }
    if (unsignedXmlDoc.documentElement.tagName == "parsererror") {
    	alert("xmldsigffext_SignEnc_xmlDocParseXmlFile(): Parsing of  XML file failed.");
    	XmlDSigEncWizardOverlay.logError("xmldsigffext_SignEnc_xmlDocParseXmlFile(): Parsing of  XML file failed.");
    	return null;
    }
    aXmlDocInFilePicker.xmldoc = unsignedXmlDoc;

    return unsignedXmlDoc;
}


function xmlDocSignPageShow(aWizardPageElem) 
{
    XmlDSigEncWizardOverlay.logTrace("xmlDocSignPageShow():................Start.");

    // gXmlDocSignEncWizardElem.canAdvance = false;


    // var pageUserNextElem = document.getElementById("xmldsigffext.signenc.xmldoc.sign.next");
    // gSigEncWizardButtonNextElem.label = pageUserNextElem.value;
    var nextLabel = aWizardPageElem.getAttribute("nextlabel");
    if (nextLabel) {
    	gSigEncWizardButtonNextElem.label = nextLabel;
    }

    if (gXmlDocSignEncWizardElem.firstStep) {
    	aWizardPageElem.firstStep = true;
    }

    var inXmlFilePickerElem = document.getElementById('xmldsigffext.signenc.xmldoc.unsigned.file.path');
    inXmlFilePickerElem.xmldoc = null;

    var inXmlFilePickerRowElem = document.getElementById('xmldsigffext.signenc.xmldoc.unsigned.file.row');
    if (!gXmlDocSignEncWizardElem.firstStep && !gXmlDocSignEncWizardElem.saveInFile) {
	inXmlFilePickerRowElem.hidden = true;
    }
    else {
        if (aWizardPageElem.filepath) {
            inXmlFilePickerElem.filepath = aWizardPageElem.filepath;
        }
	inXmlFilePickerRowElem.hidden = false;
    }
    if (gXmlDocSignEncWizardElem.firstStep) {
    	inXmlFilePickerElem.removeAttribute("browsehidden");
    	inXmlFilePickerElem.removeAttribute("readonly");
    }
    else {
    	inXmlFilePickerElem.setAttribute("browsehidden", true);
    	inXmlFilePickerElem.setAttribute("readonly", true);
    }

    if (aWizardPageElem.xmldoc) {
    	inXmlFilePickerElem.xmldoc = aWizardPageElem.xmldoc;
    }

    var outXmlFilePickerRowElem = document.getElementById("xmldsigffext.signenc.xmldoc.signed.file.row");
    // if (gXmlDocSignEncWizardElem.saveInFile || aWizardPageElem.lastStep) {
    if (gXmlDocSignEncWizardElem.saveInFile) {
    	outXmlFilePickerRowElem.hidden = false;
    }
    else {
	outXmlFilePickerRowElem.hidden = true;
    }

    handleSignInXMLFilePathChange(inXmlFilePickerElem);

    gXmlDocSignEncWizardElem.firstStep = false;
    XmlDSigEncWizardOverlay.logTrace("xmlDocSignPageShow():................End.");
    return true;
}


function handleSignInXMLFilePathChange(aFilePickerElem, ev) 
{
    XmlDSigEncWizardOverlay.logTrace("handleSignInXMLFilePathChange():................Start.");

    // XmlDSigEncWizardOverlay.logDebug("handleSignInXMLFilePathChange(): ev: " + ev + "");
    if (ev) {
	aFilePickerElem.xmldoc = null; // Force the parsing of newly choosen XML file 
        if ((aFilePickerElem.value == "") || !aFilePickerElem.file) {
    	    // XmlDSigEncWizardOverlay.logTrace("handleSignInXMLFilePathChange():................10.");
    	    gXmlDocSignEncWizardElem.canAdvance = false;
    	    return false;
        }
    }

    var unsignedXmlDoc = aFilePickerElem.xmldoc;
    // XmlDSigEncWizardOverlay.logDebug("handleSignInXMLFilePathChange(): unsignedXmlDoc: " + unsignedXmlDoc + "");
    if (!unsignedXmlDoc) {
	if (!aFilePickerElem.file) {
    	    gXmlDocSignEncWizardElem.canAdvance = false;
	    return false;
	}
    	unsignedXmlDoc = xmldsigffext_SignEnc_xmlDocParseXmlFile(aFilePickerElem);
    	if (!unsignedXmlDoc) {
    	    XmlDSigEncWizardOverlay.logError("handleSignInXMLFilePathChange(): xmldsigffext_SignEnc_xmlDocParseXmlFile() failed.");
    	    gXmlDocSignEncWizardElem.canAdvance = false;
	    return false;
    	}
    }

    if (ev) {
    	gXmlDocSignEncWizardElem.currentPage.xmldoc = unsignedXmlDoc;
    	gXmlDocSignEncWizardElem.currentPage.filepath = aFilePickerElem.filepath;
    }

    var xmlDocSignDSigBoxElem = document.getElementById("xmldsigffext.signenc.xmldoc.sign.xmldsig");
    try {
    	xmlDocSignDSigBoxElem.displayXmlDoc(unsignedXmlDoc);
    } catch (ex) {
    	XmlDSigEncWizardOverlay.logError("xmldsigffext_displayXmlDoc(): xmlDocSignDSigBoxElem.displayXmlDoc() failed - ex: " + ex + "");
    	gXmlDocSignEncWizardElem.canAdvance = false;
	return false;
    }

    var outXmlFilePickerElem = document.getElementById("xmldsigffext.signenc.xmldoc.signed.file.path");
    // if (!gXmlDocSignEncWizardElem.saveInFile && !gXmlDocSignEncWizardElem.currentPage.lastStep) {
    if (!gXmlDocSignEncWizardElem.saveInFile) {
    	gXmlDocSignEncWizardElem.canAdvance = true;
	outXmlFilePickerElem.hidden = true;
    	return true;
    }
    outXmlFilePickerElem.hidden = false;

    if ((outXmlFilePickerElem.value != "") && outXmlFilePickerElem.file) {
    	gXmlDocSignEncWizardElem.canAdvance = true;
    	// XmlDSigEncWizardOverlay.logTrace("handleSignInXMLFilePathChange():................20.");
    	return true;
    }

    var inXmlFile = aFilePickerElem.file;
    var outXmlFileName = "Signed_" + inXmlFile.leafName;
    // XmlDSigEncWizardOverlay.logDebug("handleSignInXMLFilePathChange(): outXmlFileName: " + outXmlFileName + "");

    var outXmlFileDir = inXmlFile.parent; 
    outXmlFilePickerElem.autoSelectFile(outXmlFileDir, outXmlFileName);

    handleSignOutXMLFilePathChange(outXmlFilePickerElem);

    // XmlDSigEncWizardOverlay.logDebug("xmlDocEncryptPageShow(): outXmlFilePath: " + outXmlFilePickerElem.value + "");


    XmlDSigEncWizardOverlay.logTrace("handleSignInXMLFilePathChange():................End.");
    return true;
}

function handleUnsignedXMLFileChange(ev) 
{
    var signedFilePickerElem = ev.target;
    XmlDSigEncWizardOverlay.logDebug("handleSignInXMLFileChange(): signedFilePickerElem: " + signedFilePickerElem + "");
    handleSignInXMLFilePathChange(signedFilePickerElem, ev);
}

function handleSignOutXMLFilePathChange(aFilePickerElem, ev) 
{
    if ((aFilePickerElem.value != "") && aFilePickerElem.file) {
    	gXmlDocSignEncWizardElem.canAdvance = true;
    }
    else {
    	gXmlDocSignEncWizardElem.canAdvance = false;
    }
}

function handleSignedXMLFileChange(ev) 
{
    var encyptedFilePickerElem = ev.target;
    handleSignOutXMLFilePathChange(encyptedFilePickerElem, ev);
}

function xmlDocSignPageAdvanced(aWizardPageElem) 
{
    XmlDSigEncWizardOverlay.logTrace("xmlDocSignPageAdvanced():................Start.");

    var xmlDocSignDSigBoxElem = document.getElementById("xmldsigffext.signenc.xmldoc.sign.xmldsig");
    // var signedXmlDoc = xmlDocSignDSigBoxElem.signXMLDocToFile(outXmlFilePickerElem);
    var signedXmlDoc = xmlDocSignDSigBoxElem.signXMLDoc();
    if (!signedXmlDoc) {
	alert("Failed to sign XML Doc.");
	XmlDSigEncWizardOverlay.logError("Failed to sign XML Doc.");
    	return false;
    }

    var nextPageElem = gXmlDocSignEncWizardElem.getPageById(aWizardPageElem.next);
    nextPageElem.xmldoc = signedXmlDoc;

    try {
    	// if (gXmlDocSignEncWizardElem.saveInFile || aWizardPageElem.lastStep) {
    	if (gXmlDocSignEncWizardElem.saveInFile) {
    	    var outXmlFilePickerElem = document.getElementById('xmldsigffext.signenc.xmldoc.signed.file.path');
    	    var /*nsIFile*/ signOutXmlDocFile  = outXmlFilePickerElem.file;
    	    outXmlFilePickerElem.saveXMLDocToFile(signedXmlDoc);
    	    outXmlFilePickerElem.xmldoc = signedXmlDoc;
    	    nextPageElem.filepath = outXmlFilePickerElem.filepath;
	}
    } catch (ex) {
    	XmlDSigEncWizardOverlay.logError("xmlDocEncryptPageAdvanced(): gSigEncXmlDSigTool.saveXMLDocToFile() failed - ex: " + ex + "");
    	return false;
    }

    gSigEncWizardButtonNextElem.label = gSigEncWizardButtonNextOrigLabel;

    XmlDSigEncWizardOverlay.logTrace("xmlDocSignPageAdvanced():................End.");
    return true;
}

function xmlDocVerifyPageShow(aWizardPageElem) 
{
    XmlDSigEncWizardOverlay.logTrace("xmlDocVerifyPageShow():................Start.");
    gXmlDocSignEncWizardElem.canAdvance = false;

    // var pageUserNextElem = document.getElementById("xmldsigffext.signenc.xmldoc.verify.next");
    // gSigEncWizardButtonNextElem.label = pageUserNextElem.value;
    var nextLabel = aWizardPageElem.getAttribute("nextlabel");
    if (nextLabel) {
    	gSigEncWizardButtonNextElem.label = nextLabel;
    }

    var inXmlFileGridElem = document.getElementById('xmldsigffext.signenc.xmldoc.verify.file.grid');
    var inXmlFilePickerElem = document.getElementById('xmldsigffext.signenc.xmldoc.verify.file.path');
    inXmlFilePickerElem.xmldoc = null;

    // var inXmlFilePickerRowElem = document.getElementById('xmldsigffext.signenc.xmldoc.verify.file.row');
    if (!gXmlDocSignEncWizardElem.firstStep && !gXmlDocSignEncWizardElem.saveInFile) {
	inXmlFileGridElem.hidden = true;
	// inXmlFilePickerElem.hidden = true;
    }
    else {
        if (aWizardPageElem.filepath) {
            inXmlFilePickerElem.filepath = aWizardPageElem.filepath;
        }
	// inXmlFilePickerElem.hidden = false;
	inXmlFileGridElem.hidden = false;
    }
    if (gXmlDocSignEncWizardElem.firstStep) {
    	inXmlFilePickerElem.removeAttribute("browsehidden");
    	inXmlFilePickerElem.removeAttribute("readonly");
    }
    else {
    	inXmlFilePickerElem.setAttribute("browsehidden", true);
    	inXmlFilePickerElem.setAttribute("readonly", true);
    }


    if (aWizardPageElem.xmldoc) {
    	inXmlFilePickerElem.xmldoc = aWizardPageElem.xmldoc;
    }
    handleVerifyInXMLFilePathChange(inXmlFilePickerElem);

    // var xmlDocVerifyDSigBoxElem = document.getElementById("xmldsigffext.signenc.xmldoc.verify.xmldsig");
    
    gXmlDocSignEncWizardElem.firstStep = false;

    XmlDSigEncWizardOverlay.logTrace("xmlDocVerifyPageShow():................End.");
    return true;
}

function handleVerifyInXMLFilePathChange(aFilePickerElem, ev) 
{
    XmlDSigEncWizardOverlay.logTrace("handleVerifyInXMLFilePathChange():................Start.");

    if (ev) {
	aFilePickerElem.xmldoc = null;
        if ((aFilePickerElem.value == "") || !aFilePickerElem.file) {
    	    XmlDSigEncWizardOverlay.logError("handleSignInXMLFilePathChange(): NULL signed XML file is selected.");
    	    gXmlDocSignEncWizardElem.canAdvance = false;
    	    return false;
        }
    }

    var signedXmlDoc = aFilePickerElem.xmldoc;
    if (!signedXmlDoc) {
    	signedXmlDoc = xmldsigffext_SignEnc_xmlDocParseXmlFile(aFilePickerElem);
    	if (!signedXmlDoc) {
    	    XmlDSigEncWizardOverlay.logError("handleVerifyInXMLFilePathChange(): xmldsigffext_SignEnc_xmlDocParseXmlFile() failed.");
    	    gXmlDocSignEncWizardElem.canAdvance = false;
    	    return false;
        }
    }
    var xmlDocVerifyDSigBoxElem	= document.getElementById("xmldsigffext.signenc.xmldoc.verify.xmldsig");
    try {
    	xmlDocVerifyDSigBoxElem.displayXmlDoc(signedXmlDoc);
    } catch (ex) {
    	XmlDSigEncWizardOverlay.logError("handleVerifyInXMLFilePathChange(): xmlDocVerifyDSigBoxElem.displayXmlDoc() failed - ex: " + ex + "");
    	gXmlDocSignEncWizardElem.canAdvance = false;
	return false;
    }

    if (ev) {
    	gXmlDocSignEncWizardElem.currentPage.xmldoc = signedXmlDoc;
    	gXmlDocSignEncWizardElem.currentPage.filepath = aFilePickerElem.filepath;
    }

    gXmlDocSignEncWizardElem.canAdvance = true;

    XmlDSigEncWizardOverlay.logTrace("handleVerifyInXMLFilePathChange():................End.");
    return true;
}

function handleVerifyXMLFileChange(ev) 
{
    var signedFilePickerElem = ev.target;
    handleVerifyInXMLFilePathChange(signedFilePickerElem, ev);
}

function xmlDocVerifyPageAdvanced(aWizardPageElem) 
{
    XmlDSigEncWizardOverlay.logTrace("xmlDocVerifyPageAdvanced():................Start.");
    gSigEncWizardButtonNextElem.label = gSigEncWizardButtonNextOrigLabel;

    // var xmlDocVerifyDSignatureElem = document.getElementById("xmldsigffext.signenc.xmldoc.verify.xmldsig");
    var xmlDocVerifyDSigBoxElem	= document.getElementById("xmldsigffext.signenc.xmldoc.verify.xmldsig");
    var isVerified = xmlDocVerifyDSigBoxElem.verifyXMLDoc();
    if (!isVerified) {
    	alert("Failed to verify the signature in the signed XML document.");
	return false;
    }
    alert("Successfully verified signtaure in the signed XML document.");

    /*
    var inXmlFilePickerElem = document.getElementById('xmldsigffext.signenc.xmldoc.verify.file.path');
    if (!inXmlFilePickerElem.file) {
	return false;
    }
    */

    var nextPageElem = gXmlDocSignEncWizardElem.getPageById(aWizardPageElem.next);
    nextPageElem.xmldoc = aWizardPageElem.xmldoc;

    var inXmlFilePickerElem = document.getElementById('xmldsigffext.signenc.xmldoc.verify.file.path');
    // if (gXmlDocSignEncWizardElem.saveInFile || aWizardPageElem.lastStep) {
    if (gXmlDocSignEncWizardElem.saveInFile) {
    	nextPageElem.filepath = inXmlFilePickerElem.filepath;
    }

    XmlDSigEncWizardOverlay.logTrace("xmlDocVerifyPageAdvanced():................End.");
    return isVerified;
}


function xmldsigffext_SignEnc_doOnloadInitEncParam(
	/* nsIX509 */ aKekEncryptX509Cert,
	/* String */ aKekEncryptMethodAlg,
	/* String */ aSymEncryptMethodAlg
	)
{
    XmlDSigEncWizardOverlay.logTrace("xmldsigffext_SignEnc_doOnloadInitEncParam():................Start.");

    XmlDSigEncWizardOverlay.logDebug("\taKekEncryptX509Cert: " + (aKekEncryptX509Cert?aKekEncryptX509Cert.nickname:"") + "\n\t" + 
    		"aKekEncryptMethodAlg: " + aKekEncryptMethodAlg + "\n\t" + 
    		"aSymEncryptMethodAlg: " + aSymEncryptMethodAlg + "\n\t" + 
		""
		);
    if (aSymEncryptMethodAlg && (aSymEncryptMethodAlg != "")) {
    	var symEncryptMethodElem = document.getElementById("xmldsigffext.signenc.xmldoc.encrypt.symkey.enc.method");
    	symEncryptMethodElem.Algorithm = aSymEncryptMethodAlg;
    }

    if (aKekEncryptMethodAlg && (aSymEncryptMethodAlg != "")) {
    	var kekEncryptMethodElem = document.getElementById("xmldsigffext.signenc.xmldoc.encrypt.kek.enc.method");
    	kekEncryptMethodElem.Algorithm = aKekEncryptMethodAlg;
    }
    
    if (aKekEncryptX509Cert) {
    	var kekX509CertPickerElem = document.getElementById("xmldsigffext.signenc.xmldoc.encrypt.kek.certpicker");
    	kekX509CertPickerElem.initWithCert(aKekEncryptX509Cert);
    }

    XmlDSigEncWizardOverlay.logTrace("xmldsigffext_SignEnc_doOnloadInitEncParam():................End.");
}

function initDefaultXmlDocEncryptParam()
{
    // TODO: Obtain these parameters from preferences

    var symEncryptMethodAlg	= avxmldsig.dsigtool.PrefUtil.getPreference("extensions.avxmldsig.encrypt.symkey.enc.algorithm");
    var kekEncryptMethodAlg	= avxmldsig.dsigtool.PrefUtil.getPreference("extensions.avxmldsig.encrypt.kek.enc.algorithm");
    var kekX509Cert = null;

    xmldsigffext_SignEnc_doOnloadInitEncParam(
		kekX509Cert,
		kekEncryptMethodAlg,
		symEncryptMethodAlg
    		);
}


function xmlDocEncryptPageShow(aWizardPageElem) 
{
    XmlDSigEncWizardOverlay.logTrace("xmlDocEncryptPageShow():................Start.");
    // gXmlDocSignEncWizardElem.canAdvance = false;

    // var pageUserNextElem = document.getElementById("xmldsigffext.signenc.xmldoc.encrypt.next");
    // gSigEncWizardButtonNextElem.label = pageUserNextElem.value;
    var nextLabel = aWizardPageElem.getAttribute("nextlabel");
    if (nextLabel) {
    	gSigEncWizardButtonNextElem.label = nextLabel;
    }

    var inXmlFilePickerElem = document.getElementById("xmldsigffext.signenc.xmldoc.encrypt.in.file.path");
    inXmlFilePickerElem.xmldoc = null;

    var inXmlFilePickerRowElem = document.getElementById("xmldsigffext.signenc.xmldoc.encrypt.in.file.row");
    if (!gXmlDocSignEncWizardElem.firstStep && !gXmlDocSignEncWizardElem.saveInFile) {
	inXmlFilePickerRowElem.hidden = true;
    }
    else {
        if (aWizardPageElem.filepath) {
            inXmlFilePickerElem.filepath = aWizardPageElem.filepath;
        }
	inXmlFilePickerRowElem.hidden = false;
    }
    if (gXmlDocSignEncWizardElem.firstStep) {
    	inXmlFilePickerElem.removeAttribute("browsehidden");
    	inXmlFilePickerElem.removeAttribute("readonly");
    }
    else {
    	inXmlFilePickerElem.setAttribute("browsehidden", true);
    	inXmlFilePickerElem.setAttribute("readonly", true);
    }

    if (aWizardPageElem.xmldoc) {
    	inXmlFilePickerElem.xmldoc = aWizardPageElem.xmldoc;
    }
    handleEncryptInXMLFilePathChange(inXmlFilePickerElem);

    var outXmlFilePickerElem = document.getElementById("xmldsigffext.signenc.xmldoc.encrypt.out.file.path");

    var outXmlFilePickerRowElem = document.getElementById("xmldsigffext.signenc.xmldoc.encrypt.out.file.row");
    // if (gXmlDocSignEncWizardElem.saveInFile || aWizardPageElem.lastStep) {
    if (gXmlDocSignEncWizardElem.saveInFile) {
    	outXmlFilePickerRowElem.hidden = false;
    }
    else {
	outXmlFilePickerRowElem.hidden = true;
    }


    gXmlDocSignEncWizardElem.firstStep = false;

    XmlDSigEncWizardOverlay.logTrace("xmlDocEncryptPageShow():................End.");
    return true;
}


function handleEncryptInXMLFilePathChange(aFilePickerElem, ev) 
{
    XmlDSigEncWizardOverlay.logTrace("handleEncryptInXMLFilePathChange():................Start.");

    if (ev) {
	aFilePickerElem.xmldoc = null;
        if ((aFilePickerElem.value == "") || !aFilePickerElem.file) {
    	    // XmlDSigEncWizardOverlay.logTrace("handleEncryptInXMLFilePathChange():................10.");
    	    gXmlDocSignEncWizardElem.canAdvance = false;
    	    return false;
    	}
    }

    var plainXmlDoc = aFilePickerElem.xmldoc;
    if (!plainXmlDoc) {
    	plainXmlDoc = xmldsigffext_SignEnc_xmlDocParseXmlFile(aFilePickerElem);
    	if (!plainXmlDoc) {
    	    gXmlDocSignEncWizardElem.canAdvance = false;
    	    return false;
    	}
    }

    if (ev) {
    	gXmlDocSignEncWizardElem.currentPage.xmldoc = plainXmlDoc;
    	gXmlDocSignEncWizardElem.currentPage.filepath = aFilePickerElem.filepath;
    }

    var outXmlFilePickerElem = document.getElementById("xmldsigffext.signenc.xmldoc.encrypt.out.file.path");
    // if (!gXmlDocSignEncWizardElem.saveInFile && !gXmlDocSignEncWizardElem.currentPage.lastStep) {
    if (!gXmlDocSignEncWizardElem.saveInFile) {
    	gXmlDocSignEncWizardElem.canAdvance = true;
	outXmlFilePickerElem.hidden = true;
    	return true;
    }

    outXmlFilePickerElem.hidden = false;

    if ((outXmlFilePickerElem.value != "") && outXmlFilePickerElem.file) {
    	gXmlDocSignEncWizardElem.canAdvance = true;
    	// XmlDSigEncWizardOverlay.logTrace("handleEncryptInXMLFilePathChange():................20.");
    	return true;
    }
    // XmlDSigEncWizardOverlay.logTrace("handleEncryptInXMLFilePathChange():................30.");

    var inXmlFile = aFilePickerElem.file;
    var outXmlFileName = "Encrypted_" + inXmlFile.leafName;

    // XmlDSigEncWizardOverlay.logDebug("xmlDocEncryptPageShow(): outXmlFileName: " + outXmlFileName + "");
    var outXmlFileDir = inXmlFile.parent; 
    outXmlFilePickerElem.autoSelectFile(outXmlFileDir, outXmlFileName);

    handleEncryptOutXMLFilePathChange(outXmlFilePickerElem);
    // XmlDSigEncWizardOverlay.logDebug("xmlDocEncryptPageShow(): outXmlFilePath: " + outXmlFilePickerElem.value + "");

    XmlDSigEncWizardOverlay.logTrace("handleEncryptInXMLFilePathChange():................End.");
    return false;
}

function handlePlainXMLFileChange(ev) 
{
    var signedFilePickerElem = ev.target;
    handleEncryptInXMLFilePathChange(signedFilePickerElem, ev);
}


function handleEncryptOutXMLFilePathChange(aFilePickerElem, ev) 
{
    XmlDSigEncWizardOverlay.logTrace("handleEncryptOutXMLFilePathChange():................Start.");
    if ((aFilePickerElem.value != "") && aFilePickerElem.file) {
    	gXmlDocSignEncWizardElem.canAdvance = true;
    }
    else {
    	gXmlDocSignEncWizardElem.canAdvance = false;
    }
}

function handleEncryptedXMLFileChange(ev) 
{
    // XmlDSigEncWizardOverlay.logTrace("handleEncryptedXMLFileChange():................Start.");

    var encyptedFilePickerElem = ev.target;
    handleEncryptOutXMLFilePathChange(encyptedFilePickerElem, ev);
}

function handleXmlDocEncryptCertChange(aKekCertPickerElem, ev) 
{
    XmlDSigEncWizardOverlay.logTrace("handleXmlDocEncryptCertChange():................Start.");
    XmlDSigEncWizardOverlay.logTrace("handleXmlDocEncryptCertChange():................End.");
}


function xmlDocEncryptPageAdvanced(aWizardPageElem) 
{
    XmlDSigEncWizardOverlay.logTrace("xmlDocEncryptPageAdvanced():................Start.");

    var kekX509CertPickerElem = document.getElementById("xmldsigffext.signenc.xmldoc.encrypt.kek.certpicker");

    var kekX509Cert = kekX509CertPickerElem.selectedCert;
    if (!kekX509Cert) {
    	XmlDSigEncWizardOverlay.logError("xmlDocEncryptPageAdvanced(): no encryption certificate is present.");
    	return false;
    }

    /*
    void alrIXPXmlDocSvc.encryptXMLFile (
    		in nsILocalFile aInPlainXMLFile,
		in string aEncryptionKeyType,
		in nsIX509Cert aEncryptCert,
		in string aKeyEncryptionAlgorithmURI,
		in nsILocalFile aOutEncryptedXMLFile
		);
    void encryptXMLFileWithParams (
    		in nsILocalFile aInPlainXMLFile,
		in nsIX509Cert aKekX509Cert,
		in nsIPersistentProperties aEncryptionProps,
		in nsILocalFile aOutEncryptedXMLFile
		);
    */

    var docEncryptMethodElem = document.getElementById("xmldsigffext.signenc.xmldoc.encrypt.symkey.enc.method");
    var kekKeyInfoParamElem = document.getElementById("xmldsigffext.signenc.xmldoc.encrypt.kek.keyinfo");
    var kekEncryptMethodElem = document.getElementById("xmldsigffext.signenc.xmldoc.encrypt.kek.enc.method");

    var /* nsIPersistentProperties */ xmlDocEncProps = null;
    xmlDocEncProps = Components.classes["@mozilla.org/persistent-properties;1"].
			createInstance(Components.interfaces.nsIPersistentProperties);
    kekKeyInfoParamElem.getKeyInfoParameters(xmlDocEncProps);

    docEncryptMethodElem.getParameters(xmlDocEncProps);
    kekEncryptMethodElem.getParameters(xmlDocEncProps);
    // dumpProperties(xmlDocEncProps, "xmlDocEncProps:");

    var encryptionKeyType = docEncryptMethodElem.getAttribute("Algorithm");
    var keyEncryptionAlgorithmURI = kekEncryptMethodElem.getAttribute("Algorithm");
    var encryptedXmlDoc = null;

    var encryptInXmlFilePickerElem = document.getElementById("xmldsigffext.signenc.xmldoc.encrypt.in.file.path");
    try {
	/*
    	gSigEncXmlEncSvc.encryptXMLFileWithParams(
		encryptInXmlFile,
		kekX509Cert,
		xmlDocEncProps,
		encryptOutXmlDocFile
		);
	*/
    	encryptedXmlDoc = gSigEncXmlEncSvc.encryptXMLDocWithParams(
		aWizardPageElem.xmldoc,
		kekX509Cert,
		xmlDocEncProps
		);
    } catch (ex) {
    	XmlDSigEncWizardOverlay.logError("xmlDocEncryptPageAdvanced(): gSigEncXmlEncSvc.encryptXMLDocWithParams() failed - ex: " + ex + "");
    	return false;
    }
    var nextPageElem = gXmlDocSignEncWizardElem.getPageById(aWizardPageElem.next);
    nextPageElem.xmldoc = encryptedXmlDoc;

    try {
        // if (gXmlDocSignEncWizardElem.saveInFile || aWizardPageElem.lastStep) {
    	if (gXmlDocSignEncWizardElem.saveInFile) {
            var outXmlFilePickerElem = document.getElementById("xmldsigffext.signenc.xmldoc.encrypt.out.file.path");
    	    var /*nsIFile*/ encryptOutXmlDocFile  = outXmlFilePickerElem.file;
    	    outXmlFilePickerElem.saveXMLDocToFile(encryptedXmlDoc);
    	    outXmlFilePickerElem.xmldoc = encryptedXmlDoc;
    	    nextPageElem.filepath = outXmlFilePickerElem.filepath;
	}
    } catch (ex) {
    	XmlDSigEncWizardOverlay.logError("xmlDocEncryptPageAdvanced(): gSigEncXmlDSigTool.saveXMLDocToFile() failed - ex: " + ex + "");
    	return false;
    }

    gSigEncWizardButtonNextElem.label = gSigEncWizardButtonNextOrigLabel;

    XmlDSigEncWizardOverlay.logTrace("xmlDocEncryptPageAdvanced():................End.");
    return true;
}

function xmlDocDecryptPageShow(aWizardPageElem) 
{
    XmlDSigEncWizardOverlay.logTrace("xmlDocDecryptPageShow():................Start.");

    // gXmlDocSignEncWizardElem.canAdvance = false;

    // var pageUserNextElem = document.getElementById("xmldsigffext.signenc.xmldoc.decrypt.next");
    // gSigEncWizardButtonNextElem.label = pageUserNextElem.value;
    var nextLabel = aWizardPageElem.getAttribute("nextlabel");
    if (nextLabel) {
    	gSigEncWizardButtonNextElem.label = nextLabel;
    }

    var inXmlFilePickerElem = document.getElementById("xmldsigffext.signenc.xmldoc.decrypt.in.file.path");
    inXmlFilePickerElem.xmldoc = null;

    var inXmlFilePickerRowElem = document.getElementById("xmldsigffext.signenc.xmldoc.decrypt.in.file.row");
    if (!gXmlDocSignEncWizardElem.firstStep && !gXmlDocSignEncWizardElem.saveInFile) {
	inXmlFilePickerRowElem.hidden = true;
    }
    else {
        if (aWizardPageElem.filepath) {
            inXmlFilePickerElem.filepath = aWizardPageElem.filepath;
        }
	inXmlFilePickerRowElem.hidden = false;
    }

    if (gXmlDocSignEncWizardElem.firstStep) {
    	inXmlFilePickerElem.removeAttribute("browsehidden");
    	inXmlFilePickerElem.removeAttribute("readonly");
    }
    else {
    	inXmlFilePickerElem.setAttribute("browsehidden", true);
    	inXmlFilePickerElem.setAttribute("readonly", true);
    }

    if (aWizardPageElem.xmldoc) {
    	inXmlFilePickerElem.xmldoc = aWizardPageElem.xmldoc;
    }
    XmlDSigEncWizardOverlay.logDebug("xmlDocDecryptPageShow(): inXmlFilePickerElem.xmldoc: " + inXmlFilePickerElem.xmldoc + "");
    var outXmlFilePickerRowElem = document.getElementById("xmldsigffext.signenc.xmldoc.decrypt.out.file.row");
    // if (gXmlDocSignEncWizardElem.saveInFile || aWizardPageElem.lastStep) {
    if (gXmlDocSignEncWizardElem.saveInFile) {
    	outXmlFilePickerRowElem.hidden = false;
    }
    else {
	outXmlFilePickerRowElem.hidden = true;
    }


    gXmlDocSignEncWizardElem.canAdvance = false;
    handleDecryptInXMLFilePathChange(inXmlFilePickerElem);

    gXmlDocSignEncWizardElem.firstStep = false;

    XmlDSigEncWizardOverlay.logTrace("xmlDocDecryptPageShow():................End.");
}


function handleDecryptInXMLFilePathChange(aFilePickerElem, ev) 
{
    XmlDSigEncWizardOverlay.logTrace("handleDecryptInXMLFilePathChange():................Start.");

    if (ev) {
	aFilePickerElem.xmldoc = null;
    	if ((aFilePickerElem.value == "") || !aFilePickerElem.file) {
    	    gXmlDocSignEncWizardElem.canAdvance = false;
    	    XmlDSigEncWizardOverlay.logError("handleDecryptInXMLFilePathChange(): no input XML file.");
    	    return false;
        }
    }

    var encryptedXmlDoc = aFilePickerElem.xmldoc;
    if (!encryptedXmlDoc) {
    	encryptedXmlDoc = xmldsigffext_SignEnc_xmlDocParseXmlFile(aFilePickerElem);
    	if (!encryptedXmlDoc) {
    	    gXmlDocSignEncWizardElem.canAdvance = false;
    	    return false;
    	}
    }

    if (ev) {
    	gXmlDocSignEncWizardElem.currentPage.xmldoc = encryptedXmlDoc;
    	gXmlDocSignEncWizardElem.currentPage.filepath = aFilePickerElem.filepath;
    }

    /*
    var xulEncXmlElemList = encryptedXmlDoc.getElementsByTagName("EncryptedData");
    var xulEncXmlElem = null;
    if (xulEncXmlElemList && (xulEncXmlElemList.length > 0)) {
    	xulEncXmlElem = xulEncXmlElemList.item(0);
    }
    */

    var encryptedDataBoxElem = document.getElementById("xmldsigffext.signenc.xmldoc.decrypt.encryptedDataBox");
    encryptedDataBoxElem.displayXmlDoc(encryptedXmlDoc);

    var kekX509Cert = encryptedDataBoxElem.kekX509Cert;
    // XmlDSigEncWizardOverlay.logDebug("handleDecryptInXMLFilePathChange(): kekX509Cert: " + kekX509Cert + "");
    if (!kekX509Cert) {
	var msg = "Will not be able to decrypt the XML doc - couldn't decode the KEK from keyinfo.";
	XmlDSigEncWizardOverlay.logError(msg + "");
	alert(msg);
    	gXmlDocSignEncWizardElem.canAdvance = false;
    	return false;
    }

    // XmlDSigEncWizardOverlay.logDebug("handleDecryptInXMLFilePathChange(): kekX509Cert: " + kekX509Cert.nickname + "");
    if (!gSigEncX509CertDBUtil.isUserCert(kekX509Cert)) {
	var msg = "Will not be able to decrypt the XML doc - No private key associate with the KEK cert for " + kekX509Cert.nickname + " in the Certificate DB."
	XmlDSigEncWizardOverlay.logError(msg + "");
	alert(msg);
    	gXmlDocSignEncWizardElem.canAdvance = false;
    	return false;
    }
    gXmlDocSignEncWizardElem.canAdvance = true;

    var outXmlFilePickerElem = document.getElementById("xmldsigffext.signenc.xmldoc.decrypt.out.file.path");
    // if (!gXmlDocSignEncWizardElem.saveInFile && !gXmlDocSignEncWizardElem.currentPage.lastStep) {
    if (!gXmlDocSignEncWizardElem.saveInFile) {
    	gXmlDocSignEncWizardElem.canAdvance = true;
    	return true;
    }

    if ((outXmlFilePickerElem.value != "") && outXmlFilePickerElem.file) {
    	gXmlDocSignEncWizardElem.canAdvance = true;
    	return true;
    }
    // XmlDSigEncWizardOverlay.logDebug("handleDecryptInXMLFilePathChange(): no output XML file.");

    var inXmlFile = aFilePickerElem.file;
    var outXmlFileName = "Plain_" + inXmlFile.leafName;
    // XmlDSigEncWizardOverlay.logDebug("handleDecryptInXMLFilePathChange(): outXmlFileName: " + outXmlFileName + "");

    var outXmlFileDir = inXmlFile.parent; 
    outXmlFilePickerElem.autoSelectFile(outXmlFileDir, outXmlFileName);
    handleDecryptedOutXMLFilePathChange(outXmlFilePickerElem);
    // XmlDSigEncWizardOverlay.logDebug("handleDecryptInXMLFilePathChange(): outXmlFilePath: " + outXmlFilePickerElem.value + "");

    XmlDSigEncWizardOverlay.logTrace("handleDecryptInXMLFilePathChange():................End.");
    return true;
}

function handleDecryptInXMLFileChange(ev) 
{
    var decyptInFilePickerElem = ev.target;
    // handleDecryptInXMLFilePathChange(decyptInFilePickerElem, ev);
    handleDecryptInXMLFilePathChange(decyptInFilePickerElem);
}

function handleDecryptedOutXMLFilePathChange(aTargetElem, ev) 
{
    // XmlDSigEncWizardOverlay.logTrace("handleDecryptedOutXMLFilePathChange():................Start.");
    if ((aTargetElem.value != "") && aTargetElem.file) {
    	gXmlDocSignEncWizardElem.canAdvance = true;
    }
    // XmlDSigEncWizardOverlay.logTrace("handleDecryptedOutXMLFilePathChange():................End.");
}

function handleDecryptedXMLFileChange(ev) 
{
    var decyptedFilePickerElem = ev.target;
    handleDecryptedXMLFilePathChange(decyptedFilePickerElem, ev);
}

function xmlDocDecryptPageAdvanced(aWizardPageElem) 
{
    XmlDSigEncWizardOverlay.logTrace("xmlDocDecryptPageAdvanced():................Start.");

    var inXmlFilePickerElem = document.getElementById("xmldsigffext.signenc.xmldoc.decrypt.in.file.path");
    var /*nsIFile*/ encryptedXmlDocFile  = inXmlFilePickerElem.file;
    // XmlDSigEncWizardOverlay.logDebug("xmlDocDecryptPageShow(): inXmlFilePickerElem.xmldoc: " + inXmlFilePickerElem.xmldoc + "");

    var encryptedDataBoxElem = document.getElementById("xmldsigffext.signenc.xmldoc.decrypt.encryptedDataBox");
    var kekX509Cert = encryptedDataBoxElem.kekX509Cert;
    if (kekX509Cert) {
    	if (!gSigEncX509CertDBUtil.isUserCert(kekX509Cert)) {
	    var msg = "Unable to decrypt the XML doc - No private key associate with this KEK cert in the DB."
	    XmlDSigEncWizardOverlay.logError(msg + "");
	    alert(msg);
	    return false;
	}
    }

    /*
    void alrIXPXmlDocSvc.decryptXMLDoc (
    		in nsILocalFile aInPlainXMLDoc,
		inout nsIX509Cert aEncryptCert,
		);
    */

    var kekX509CertObj = new Object();
    if (kekX509Cert) {
    	kekX509CertObj.value = kekX509Cert;
    }
    var plainXmlDoc = null;
    try {
    	plainXmlDoc = gSigEncXmlEncSvc.decryptXMLDoc(
		inXmlFilePickerElem.xmldoc,
		kekX509CertObj
		);
    	if (!kekX509Cert && kekX509CertObj.value) {
	    kekX509Cert = kekX509CertObj.value;
	}
    } catch (ex) {
    	XmlDSigEncWizardOverlay.logError("xmlDocDecryptPageAdvanced(): gSigEncXmlEncSvc.decryptXMLDoc() failed - ex: " + ex + "");
    	alert("Failed to decrypt the document.");
    	return false;
    }
    alert("Successfully decrypted the document.");

    // XmlDSigEncWizardOverlay.logDebug("xmlDocDecryptPageAdvanced(): aWizardPageElem.next: " + aWizardPageElem.next + "");
    var nextPageElem = gXmlDocSignEncWizardElem.getPageById(aWizardPageElem.next);
    nextPageElem.xmldoc = plainXmlDoc;

    try {
        // if (gXmlDocSignEncWizardElem.saveInFile || aWizardPageElem.lastStep) {
    	if (gXmlDocSignEncWizardElem.saveInFile) {
    	    var outXmlFilePickerElem = document.getElementById("xmldsigffext.signenc.xmldoc.decrypt.out.file.path");
    	    var /*nsIFile*/ plainXmlDocFile  = outXmlFilePickerElem.file;
    	    outXmlFilePickerElem.saveXMLDocToFile(plainXmlDoc);
    	    outXmlFilePickerElem.xmldoc = plainXmlDoc;
    	    nextPageElem.filepath = outXmlFilePickerElem.filepath;
	}
    } catch (ex) {
    	XmlDSigEncWizardOverlay.logError("xmlDocDecryptPageAdvanced(): gSigEncXmlEncSvc.saveXMLDocToFile() failed - ex: " + ex + "");
    	return false;
    }

    gSigEncWizardButtonNextElem.label = gSigEncWizardButtonNextOrigLabel;

    XmlDSigEncWizardOverlay.logTrace("xmlDocDecryptPageAdvanced():................End.");
    return true;
}

function xmlDocVerify2PageShow(aWizardPageElem) 
{
    XmlDSigEncWizardOverlay.logTrace("xmlDocVerify2PageShow():................Start.");
    // gXmlDocSignEncWizardElem.canAdvance = false;

    // var pageUserNextElem = document.getElementById("xmldsigffext.signenc.xmldoc.verify2.next");
    // gSigEncWizardButtonNextElem.label = pageUserNextElem.value;
    var nextLabel = aWizardPageElem.getAttribute("nextlabel");
    if (nextLabel) {
    	gSigEncWizardButtonNextElem.label = nextLabel;
    }

    var inXmlFileGridElem = document.getElementById('xmldsigffext.signenc.xmldoc.verify2.file.grid');
    var inXmlFilePickerElem = document.getElementById('xmldsigffext.signenc.xmldoc.verify2.file.path');

    // var inXmlFilePickerRowElem = document.getElementById("xmldsigffext.signenc.xmldoc.verify2.file.row");
    if (!gXmlDocSignEncWizardElem.firstStep && !gXmlDocSignEncWizardElem.saveInFile) {
	// inXmlFilePickerElem.hidden = true;
	inXmlFileGridElem.hidden = true;
    }
    else {
        if (aWizardPageElem.filepath) {
            inXmlFilePickerElem.filepath = aWizardPageElem.filepath;
        }
	// inXmlFilePickerElem.hidden = false;
	inXmlFileGridElem.hidden = false;
    }

    if (aWizardPageElem.xmldoc) {
    	inXmlFilePickerElem.xmldoc = aWizardPageElem.xmldoc;
    }
    
    var plainXmlDoc = inXmlFilePickerElem.xmldoc;
    if (!plainXmlDoc) {
    	plainXmlDoc = xmldsigffext_SignEnc_xmlDocParseXmlFile(inXmlFilePickerElem);
    }
    
    var xmlDocVerifyTokenDSignatureElem = document.getElementById("xmldsigffext.signenc.xmldoc.verify2.xmldsig");
    xmlDocVerifyTokenDSignatureElem.displayXmlDoc(plainXmlDoc);

    gXmlDocSignEncWizardElem.firstStep = false;

    XmlDSigEncWizardOverlay.logTrace("xmlDocVerify2PageShow():................End.");
    return true;
}

function xmlDocVerify2PageAdvanced(aWizardPageElem) 
{
    // XmlDSigEncWizardOverlay.logTrace("xmlDocVerify2PageAdvanced():................Start.");
    gSigEncWizardButtonNextElem.label = gSigEncWizardButtonNextOrigLabel;

    var xmlDocVerifyTokenDSignatureElem = document.getElementById("xmldsigffext.signenc.xmldoc.verify2.xmldsig");
    var isVerified = xmlDocVerifyTokenDSignatureElem.verifyXMLDoc();
    if (!isVerified) {
    	alert("Failed to verify the signature in the signed XML document.");
	return false;
    }
    alert("Successfully verified signtaure in the signed XML document.");


    // XmlDSigEncWizardOverlay.logDebug("xmlDocVerify2PageAdvanced(): aWizardPageElem.next: " + aWizardPageElem.next + "");
    var nextPageElem = gXmlDocSignEncWizardElem.getPageById(aWizardPageElem.next);
    nextPageElem.xmldoc = aWizardPageElem.xmldoc;

    var inXmlFilePickerElem = document.getElementById('xmldsigffext.signenc.xmldoc.verify2.file.path');
    // if (gXmlDocSignEncWizardElem.saveInFile || aWizardPageElem.lastStep) {
    if (gXmlDocSignEncWizardElem.saveInFile) {
    	nextPageElem.filepath = inXmlFilePickerElem.filepath;
    }

    // XmlDSigEncWizardOverlay.logDebug("xmlDocVerify2PageAdvanced():................End.");
    return isVerified;
}

