/* @(#) $Id: XmlDigitalSignatureForm.js,v 1.19 2012/10/03 23:08:12 subrata Exp $ */

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is  Avaya Labs Research, Avaya Inc. Code.
 *
 * The Initial Developer of the Original Code is
 *     Subrata Mazumdar, Avaya Labs Research, Avaya Inc.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Subrata Mazumdar (mazum@avaya.com)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


var XmlDigitalSigTool = {
    mMaxLogLevel		: 2,
    log : function(level, msg)
    {
	if (level > XmlDigitalSigTool.mMaxLogLevel) {
            return;
        }
        dump(msg + "");
    },

    dump : function(msg)
    {
        XmlDigitalSigTool.log(1, msg);
    },
    logError : function(msg)
    {
        XmlDigitalSigTool.log(2, msg);
    },
    logTrace : function(msg)
    {
        XmlDigitalSigTool.log(4, msg);
    },
    logDebug : function(msg)
    {
        XmlDigitalSigTool.log(8, msg);
    },
    lastMethod : function () 
    {
    }
};


var gXmlDSigInputFileIsSignedElem;
var gXmlDSigInputFilePickerElem;
var gXmlDSigResignRowElem;
var gXmlDSigResignElem;

var gXmlDSigSignatureOverlayElem;
var gXmlDSigEditorElem;

var gXmlDSigSignedOutDocGridElem;

var gXmlDSigSignedOutFilePickerRowElem;
var gXmlDSigSignedOutFilePickerElem;
var gXmlDSigSignedOutDocVerifyElem;
var gXmlDSigEnableEncryptRowElem;

// var gXmlParser;
// var gXmlSerializer;

function xmldsigffext_initVerifyFormXULElems()
{
    // XmlDigitalSigTool.logTrace("xmldsigffext_initVerifyFormXULElems():................Start.");

    var xmlDSigSignedOutDocGridElem = document.getElementById("xmldsigffext.form.xmlsig.in.doc.grid"); 
    gXmlDSigInputFilePickerElem		= document.getElementById("xmldsigffext.form.sign.file.in.xmldoc.path");
    gXmlDSigInputFileIsSignedElem	= document.getElementById("xmldsigffext.form.sign.file.in.xmldoc.issigned");
    gXmlDSigResignRowElem		= document.getElementById("xmldsigffext.form.sign.resign.row");
    gXmlDSigResignElem			= document.getElementById("xmldsigffext.form.sign.resign");
    // xmlDSigSignedOutDocGridElem.hidden = false;


    gXmlDSigSignatureOverlayElem	= document.getElementById("xmldsigffext.form.xmlsig.overlay");
    gXmlDSigEditorElem		= document.getElementById("xmldsigffext.form.signature.box");

    gXmlDSigSignedOutDocGridElem 	= document.getElementById("xmldsigffext.form.xmlsig.out.doc.grid"); 

    gXmlDSigSignedOutFilePickerRowElem = document.getElementById("xmldsigffext.form.sign.file.out.xmldoc.row"); 
    gXmlDSigSignedOutFilePickerElem	= document.getElementById("xmldsigffext.form.sign.file.out.xmldoc.path"); 
    gXmlDSigSignedOutDocVerifyElem	= document.getElementById("xmldsigffext.form.sign.file.out.xmldoc.verify"); 

    // gXmlDSigEnableEncryptRowElem 	= document.getElementById("xmldsigffext.form.encrypt.enable.row"); 

    gXmlDSigInputFilePickerElem.addEventListener('command', xmldsigffext_xmlDocFileChangeHandler, false);
    gXmlDSigInputFilePickerElem.addEventListener('change', xmldsigffext_xmlDocFileChangeHandler, false);
    gXmlDSigInputFilePickerElem.addEventListener('popuphiding', xmldsigffext_xmlDocFileChangeHandler, false);

    // xmldsigffext_xmlDocFileChangeHandler();
    xmldsigffext_initSignVerifySig();

    // gXmlParser = new DOMParser();
    // gXmlSerializer = new XMLSerializer();


    // XmlDigitalSigTool.logTrace("xmldsigffext_initVerifyFormXULElems():................End.");
}

function xmldsigffext_initSignVerifySig()
{
    gXmlDSigSignatureOverlayElem.hidden = true;
}

function xmldsigffext_doOnloadInitSignParam(/* String */ inXmlFilePath, /* String */ outXmlFilePath, /* nsIX509 */ aSelectedSignerCert)
{
    XmlDigitalSigTool.logTrace("xmldsigffext_doOnloadInitSignParam():................Start.");
    // xmldsigffext_initVerifyFormXULElems();

    XmlDigitalSigTool.logDebug("inXmlFilePath: " + inXmlFilePath + " " + 
    		"outXmlFilePath: " + outXmlFilePath + " " + 
    		"cert: " + (aSelectedSignerCert?aSelectedSignerCert.nickname:"") + " " + 
		"");
    if (inXmlFilePath) {
	if ((inXmlFilePath.indexOf("http://") == 0) 
	    || (inXmlFilePath.indexOf("https://") == 0) 
	    || (inXmlFilePath.indexOf("file://") == 0) 
	    ) {
	    xmldsigffext_inputXmlDocURIChangeHandler(inXmlFilePath);
	    return;
    	}
    }


    if (inXmlFilePath) {
    	gXmlDSigInputFilePickerElem.value = inXmlFilePath;
	gXmlDSigInputFilePickerElem.disabled = true;
    }


    xmldsigffext_xmlDocFileChangeHandler(null);
    /*
    if (aSelectedSignerCert) {
    	// xmldsigffext_setUserCredential(aSelectedSignerCert);
    }
    */

    if (outXmlFilePath) {
    	gXmlDSigSignedOutFilePickerElem.value = outXmlFilePath;
	gXmlDSigSignedOutFilePickerElem.disabled = true;
    }
    XmlDigitalSigTool.logTrace("xmldsigffext_doOnloadInitSignParam():................End.");
}

function xmldsigffext_setInputXMLFilePath(xmlFilePath)
{
    gXmlDSigInputFilePickerElem.value = xmlFilePath;
}


function xmldsigffext_enableForUnsignedXmlDoc()
{
    // XmlDigitalSigTool.logTrace("xmldsigffext_enableForUnsignedXmlDoc():................Start.");

    // xmldsigffext_enabledSignedInfo(true);

    gXmlDSigInputFileIsSignedElem.hidden = true;

    // gXmlDSigResignRowElem.hidden = true;
    // gXmlDSigResignElem.checked = false;

    xmldsigffext_enableForSign();

    gXmlDSigSignedOutFilePickerRowElem.hidden = false;
    // gXmlDSigEnableEncryptRowElem.hidden = false;
    gXmlDSigSignedOutDocGridElem.hidden = false;

    // XmlDigitalSigTool.logTrace("xmldsigffext_enableForUnsignedXmlDoc():................End.");
}


function xmldsigffext_enableForSignedXmlDoc()
{
    // XmlDigitalSigTool.logTrace("xmldsigffext_enableForSignedXmlDoc():................Start.");

    gXmlDSigInputFileIsSignedElem.hidden = false;

    gXmlDSigResignRowElem.hidden = false;
    gXmlDSigResignElem.checked = false;

    xmldsigffext_enableForVerify();

    gXmlDSigSignedOutDocGridElem.hidden = true;
    gXmlDSigSignedOutFilePickerRowElem.hidden = true;
    // gXmlDSigEnableEncryptRowElem.hidden = true;

    // XmlDigitalSigTool.logTrace("xmldsigffext_enableForSignedXmlDoc():................End.");
}

function xmldsigffext_displayXmlDoc(aXmlDoc)
{
    // XmlDigitalSigTool.logTrace("xmldsigffext_displayXmlDoc():................Start.");

    gXmlDSigSignatureOverlayElem.hidden = false;
    try {
    	gXmlDSigEditorElem.displayXmlDoc(aXmlDoc);
    } catch (ex) {
    	XmlDigitalSigTool.logError("xmldsigffext_displayXmlDoc(): gXmlDSigEditorElem.displayXmlDoc() failed - ex: " + ex + "");
    	alert("xmldsigffext_displayXmlDoc(): failed to create and display XML signature - ex: " + ex + "");
    	gXmlDSigSignatureOverlayElem.hidden = true;
	return;
    }


    var isSignedXMLDoc = gXmlDSigEditorElem.isSignedXmlDoc;
    XmlDigitalSigTool.logDebug("xmldsigffext_displayXmlDoc(): isSignedXMLDoc: " + isSignedXMLDoc + "");
    XmlDigitalSigTool.logDebug("xmldsigffext_displayXmlDoc(): gXmlDSigJsonParams.signerX509Cert: " + gXmlDSigJsonParams.signerX509Cert + "");
    if (!isSignedXMLDoc && gXmlDSigJsonParams.signerX509Cert) {
    	try {
	    gXmlDSigEditorElem.signerCert = gXmlDSigJsonParams.signerX509Cert;
	} catch (ex) {
	    XmlDigitalSigTool.logError("xmldsigffext_displayXmlDoc(): gXmlDSigEditorElem.displayXmlDoc() failed - ex: " + ex + "");
	}
    }

    gXmlDSigResignRowElem.hidden = !isSignedXMLDoc;
    if (isSignedXMLDoc) {
    	xmldsigffext_enableForSignedXmlDoc();

    	gXmlDSigResignElem.disabled = false;
	var credentialType = gXmlDSigEditorElem.credentialType;
    	XmlDigitalSigTool.logDebug("xmldsigffext_displayXmlDoc(): credentialType: " + credentialType + "");
	if ("certificate" == credentialType) {
	    var isUserCert = false;
	    var signerCert = gXmlDSigEditorElem.docSignerCert;
	    if (signerCert) {
	    	isUserCert = gX509CertDBUtil.isUserCert(signerCert);
    	    	XmlDigitalSigTool.logDebug("xmldsigffext_displayXmlDoc(): signerCert: " + signerCert.nickname + " isUserCert: " + isUserCert + "");
	    }
	    if (!isUserCert) {
    	    	XmlDigitalSigTool.logDebug("xmldsigffext_displayXmlDoc(): signer cert is does not have private key in CertDB - disabling editing of signature.");
    	    	gXmlDSigResignElem.disabled = true;
	    }
	}
	else {
	    gXmlDSigEditorElem.signerSharedKey = "";
	}
    }
    else {
    	xmldsigffext_enableForUnsignedXmlDoc();
    	// gXmlDSigResignRowElem.hidden = true;
	gXmlDSigSignedOutFilePickerElem.value = "";
    }

    // XmlDigitalSigTool.logTrace("xmldsigffext_displayXmlDoc():................End.");
}

function xmldsigffext_xmlDocFileChangeHandler(ev)
{
    // XmlDigitalSigTool.logTrace("xmldsigffext_xmlDocFileChangeHandler():................Start.");


    var xmlDSigInputFilePickerElem = gXmlDSigInputFilePickerElem;
    if (ev) {
    	xmlDSigInputFilePickerElem = ev.currentTarget;
    }
    xmldsigffext_inputXmlDocFileChangeHandler(xmlDSigInputFilePickerElem, ev);
    
    // XmlDigitalSigTool.logTrace("xmldsigffext_xmlDocFileChangeHandler():................End.");
}

function xmldsigffext_inputXmlDocFileChangeHandler(aXmlDSigInputFilePickerElem, ev)
{

    XmlDigitalSigTool.logTrace("xmldsigffext_inputXmlDocFileChangeHandler():................Start.");
    
    gXmlDSigSignatureOverlayElem.hidden = true;
    gXmlDSigSignedOutDocVerifyElem.hidden = true;

    var inputXmlFile = gXmlDSigInputFilePickerElem.file;
    if (inputXmlFile == null) {
    	alert("xmldsigffext_inputXmlDocFileChangeHandler(): Input XML file path is missing.");
    	XmlDigitalSigTool.logError("xmldsigffext_inputXmlDocFileChangeHandler(): Input XML file path is missing.");
    	return;
    }
    if (!inputXmlFile.exists()) {
    	alert("xmldsigffext_inputXmlDocFileChangeHandler(): Input XML file does not exists.");
    	XmlDigitalSigTool.logError("xmldsigffext_inputXmlDocFileChangeHandler(): Input XML file does not exists.");
    	return;
    }
    if (inputXmlFile.fileSize == 0) {
    	alert("xmldsigffext_inputXmlDocFileChangeHandler(): Zero-length XML file - pick another one.");
    	XmlDigitalSigTool.logError("xmldsigffext_inputXmlDocFileChangeHandler(): Zero-length XML file - pick another one.");
    	return;
    }
    XmlDigitalSigTool.logDebug("xmldsigffext_inputXmlDocFileChangeHandler(): inXmlFilePath: " + gXmlDSigInputFilePickerElem.filepath + "");


    var /* nsIDOMDocument */ xmlDoc = null;
    try {
    	xmlDoc = gXmlDSigTool.readXMLDocFromFile(inputXmlFile);
    } catch (ex) {
    	alert("xmldsigffext_inputXmlDocFileChangeHandler(): Not a valid XML file - parsing error.");
    	XmlDigitalSigTool.logError("xmldsigffext_inputXmlDocFileChangeHandler(): Not a valid XML file - parsing error.");
    	return;
    }
    if (!xmlDoc) {
    	alert("xmldsigffext_inputXmlDocFileChangeHandler(): Not a valid XML file.");
    	XmlDigitalSigTool.logError("xmldsigffext_inputXmlDocFileChangeHandler(): Not a valid XML file.");
    	return;
    }
    if (xmlDoc.documentElement.tagName == "parsererror") {
    	alert("xmldsigffext_inputXmlDocFileChangeHandler(): Parsing of  XML file failed.");
    	XmlDigitalSigTool.logError("xmldsigffext_inputXmlDocFileChangeHandler(): Parsing of  XML file failed.");
    	return;
    }
    gXmlDSigInputFilePickerElem.xmlDoc = xmlDoc;

    /*
    setTimeout(function() {
    	xmldsigffext_displayXmlDoc(gXmlDSigInputFilePickerElem.xmlDoc);
    }, 100);
    */
    xmldsigffext_displayXmlDoc(gXmlDSigInputFilePickerElem.xmlDoc);


    XmlDigitalSigTool.logTrace("xmldsigffext_inputXmlDocFileChangeHandler():................End.");
}

function xmldsigffext_inputXmlDocURIChangeHandler(aXmlDSigInputURISpec, ev)
{
    var /* nsIDOMDocument */ xmlDoc = gXmlDSigTool.readXMLDocFromURIPath(aXmlDSigInputURISpec);
    if (!xmlDoc) {
    	alert("xmldsigffext_inputXmlDocURIChangeHandler(): Failed to load XML Doc usin the URI: " + aXmlDSigInputURISpec + ".");
    	XmlDigitalSigTool.logError("xmldsigffext_inputXmlDocURIChangeHandler(): Failed to load XML Doc usin the URI: " + aXmlDSigInputURISpec + ".");
    	return;
    }
    var xmlDSigSignedOutDocGridElem = document.getElementById("xmldsigffext.form.xmlsig.in.doc.grid"); 
    xmlDSigSignedOutDocGridElem.hidden = true;

    xmldsigffext_displayXmlDoc(xmlDoc);
}

function xmldsigffext_handleModifySignature(modifySigCheckBoxElem)
{
    // XmlDigitalSigTool.logTrace("xmldsigffext_handleModifySignature():................End.");

    if (modifySigCheckBoxElem.checked) {
	gXmlDSigEditorElem.enableModifySignature(modifySigCheckBoxElem.checked);
	gXmlDSigSignedOutFilePickerElem.value = "";
    	xmldsigffext_enableForUnsignedXmlDoc();
    }
    else {
    	xmldsigffext_displayXmlDoc(gXmlDSigInputFilePickerElem.xmlDoc);
    	xmldsigffext_enableForSignedXmlDoc();
    }
    // XmlDigitalSigTool.logTrace("xmldsigffext_handleModifySignature():................End.");
}


function xmldsigffext_autoSelectOutSignedFile(/* nsILocalFile */ inputXMLFile)
{
    var outSignedFileName = null;

    outSignedFileName = "TmpXMLFile.xml";
    if (inputXMLFile) {
    	outSignedFileName = inputXMLFile.leafName;
    }
    if (outSignedFileName.indexOf("_SIGNATURE") < 0) {
    	outSignedFileName =
			(gXmlDSigEditorElem.signerAlias?gXmlDSigEditorElem.signerAlias:"UserX") + 
			/*
			"_" + gXmlDSigEditorElem.credentialType + 
			*/
			"_" + gXmlDSigEditorElem.signerKeyType + 
			"_" + gXmlDSigEditorElem.signatureType + 
			"_" + gXmlDSigEditorElem.canonicalizationMethodName + 
			"_" + inputXMLFile.leafName + 
			"";
    	// XmlDigitalSigTool.logDebug("xmldsigffext_autoSelectOutSignedFile(): outSignedFileName: " + outSignedFileName + "");
    }
    
    return xmldsigffext_autoSelectOutFile(gXmlDSigSignedOutFilePickerElem, outSignedFileName);
}

function xmldsigffext_previewXMLDoc()
{
    XmlDigitalSigTool.logTrace("xmldsigffext_previewXMLDoc():..................Start.");

    var previewFilePickerElem = document.getElementById('xmldsigffext.form.preview.xmldoc.filepicker');

    var xmlDoc = null;
    var xmlDoc = gXmlDSigEditorElem.getXmlDocWithSigTransforms();
    var xmlDocStr = gXmlSerializer.serializeToString(xmlDoc);
    XmlDigitalSigTool.logDebug("xmldsigffext_previewXMLDoc(): xmlDocStr: \n" + xmlDocStr + "");
    if (previewFilePickerElem.file) {
	previewFilePickerElem.file.remove(false);
	previewFilePickerElem.filepath = "";
    }

    var tmpOutFile = previewFilePickerElem.autoSelectTempFile("XMLDSigTool", "PreviewTempXmlDoc.xml");
    previewFilePickerElem.saveFile(xmlDocStr);
    previewFilePickerElem.refresh();
    previewFilePickerElem.viewFile();

    XmlDigitalSigTool.logTrace("xmldsigffext_previewXMLDoc():..................End.");
}

/* nsIDOMDocument  */
function xmldsigffext_signXMLDocWithSharedKey(/* nsIDOMDocument  */ xmlDoc, /* nsIPersistentProperties */ xmlSignatureProps)
{
    // XmlDigitalSigTool.logTrace("xmldsigffext_signXMLDocWithSharedKey():................Start.");


    var outSignedXmlDoc = null;
    try {
    	outSignedXmlDoc = gXmlDSigTool.signXMLDocBySharedKey(xmlDoc, xmlSignatureProps);
    } catch (ex) {
    	// alert("xmldsigffext_signXMLFileWithSharedKey(): failed to create signed XML file - ex : " + ex + "");
    	XmlDigitalSigTool.logError("xmldsigffext_signXMLDocWithSharedKey(): failed to create signed XML file - ex : " + ex + "");
	throw ex;
    }

    // XmlDigitalSigTool.logTrace("xmldsigffext_signXMLDocWithSharedKey():................End.");

    return outSignedXmlDoc;

}


/* nsIDOMDocument  */
function xmldsigffext_signXMLDocWithCert(/* nsIDOMDocument  */ xmlDoc, /* nsIX509Cert */ signerCert, /* nsIPersistentProperties */ xmlSignatureProps)
{
    // XmlDigitalSigTool.logTrace("xmldsigffext_signXMLDocWithCert():................Start.");


    var outSignedXmlDoc = null;
    try {
    	// Force token login - on windows the popup window for password is not coming up
    	xmldsigffext_loginToCertToken(signerCert);
    	outSignedXmlDoc = gXmlDSigTool.signXMLDocByX509Cert(xmlDoc, signerCert, xmlSignatureProps);
    } catch (ex) {
    	alert("xmldsigffext_signXMLDocWithCert(): failed to sign XML file - ex : " + ex + "");
    	XmlDigitalSigTool.logError("xmldsigffext_signXMLDocWithCert(): failed to sign XML file - ex : " + ex + "");
	throw ex;
    }

    // XmlDigitalSigTool.logTrace("xmldsigffext_signXMLDocWithCert():................End.");

    return outSignedXmlDoc;
}


/* nsIDOMDocument */
function xmldsigffext_signXMLDoc()
{
    XmlDigitalSigTool.logTrace("xmldsigffext_signXMLDoc():................Start.");

    var signedXmlDoc = null;

    var xmlDoc = gXmlDSigInputFilePickerElem.xmlDoc;
    var preSignedXmlDoc = gXmlDSigEditorElem.getXmlDocWithSigTransforms();
    if (!preSignedXmlDoc) {
	XmlDigitalSigTool.logError("xmldsigffext_signXMLDoc(): getXmlDocWithSigTransforms() failed - NULL XML doc.");
	alert("xmldsigffext_signXMLDoc(): failed to create partially filled XML Signature element for the XML document.");
	throw ("xmldsigffext_signXMLDoc(): failed to create partially filled XML Signature element for the XML document.");
    }

    /*
    var preSignedXmlDocStr = gXmlSerializer.serializeToString(preSignedXmlDoc);
    XmlDigitalSigTool.logDebug("xmldsigffext_signXMLDoc(): preSignedXmlDocStr: \n" + preSignedXmlDocStr + "");
    */

    /*
    var xmlDoc1 = gXmlDSigEditorElem.getXmlDocWithSigTransforms();
    var xmlDoc1Str = gXmlSerializer.serializeToString(xmlDoc1);
    XmlDigitalSigTool.logDebug("xmldsigffext_signXMLDoc(): xmlDoc1Str: \n" + xmlDoc1Str + "");
    */

    var /* nsIPersistentProperties */ xmlSignatureProps = gXmlDSigEditorElem.getSignatureProperties();
    /*
    gXmlDSigEditorElem.dumpProperties(xmlSignatureProps, "Signing Props:");
    */

    // var credentialType = xmldsigffext_getUserCredentialType();
    var credentialType = gXmlDSigEditorElem.credentialType;
    if (credentialType == "certificate") {
        var /* nsIX509Cert */ signerCert;
        signerCert = gXmlDSigEditorElem.signerCert;
        if (signerCert == null) {
    	    XmlDigitalSigTool.logError("xmldsigffext_signXMLDoc(): null signerCert - you must choose a signer certificate.");
    	    alert("xmldsigffext_signXMLDoc(): null signerCert - you must choose a signer certificate.");
    	    throw ("null signerCert - you must choose a signer certificate.");
        }
    	signedXmlDoc = xmldsigffext_signXMLDocWithCert(preSignedXmlDoc, signerCert, xmlSignatureProps);
    }
    else if (credentialType == "password") {
    	var sharedKey = gXmlDSigEditorElem.signerSharedKey;
        if (sharedKey.length == 0) {
    	    alert("xmldsigffext_signXMLDoc(): shared key is missing.");
    	    XmlDigitalSigTool.logError("xmldsigffext_signXMLDoc(): shared key is missing.");
    	    throw("xmldsigffext_signXMLDoc(): shared key is missing.");
        }
    	signedXmlDoc = xmldsigffext_signXMLDocWithSharedKey(preSignedXmlDoc, xmlSignatureProps);
    }
    else {
    	signedXmlDoc = null;
    	throw ("Invalid credential option.");
    }
    if (!signedXmlDoc) {
    	return null;
    }

    /*
    signedXmlDocStr = gXmlSerializer.serializeToString(signedXmlDoc);
    XmlDigitalSigTool.logDebug("xmldsigffext_signXMLDoc(): signedXmlDocStr: \n" + signedXmlDocStr + "");
    */


    XmlDigitalSigTool.logTrace("xmldsigffext_signXMLDoc():................End.");
    return signedXmlDoc;
}

/* nsIDOMDocument */
function xmldsigffext_signXMLDocToFile()
{
    XmlDigitalSigTool.logTrace("xmldsigffext_signXMLDocToFile():................Start.");

    // Select path to the signed XML File 
    var /* nsILocalFile */ outSignedXmlDocFile = null;
    if (gXmlDSigSignedOutFilePickerElem.value == "") {
	xmldsigffext_autoSelectOutSignedFile(gXmlDSigInputFilePickerElem.file);
    }
    outSignedXmlDocFile = gXmlDSigSignedOutFilePickerElem.file;
    if (outSignedXmlDocFile == null) {
    	XmlDigitalSigTool.logError("xmldsigffext_signXMLDocToFile(): path to output signed XML document is missing or invalid.");
    	throw ("xmldsigffext_signXMLDocToFile(): path to output signed XML document is missing or invalid.");
    }
    // XmlDigitalSigTool.logDebug("xmldsigffext_signXMLDocToFile(): outSignedXmlDocFile: " + outSignedXmlDocFile.path + "");


    // Create signed XML doc 
    var /* nsIDOMDocument */ signedXmlDoc = null;
    signedXmlDoc = xmldsigffext_signXMLDoc();
    if (!signedXmlDoc) {
    	return null;
    }

    // Save signed XML doc 

    var signedXmlDocStr = gXmlSerializer.serializeToString(signedXmlDoc);
    gXmlDSigSignedOutFilePickerElem.saveFile(signedXmlDocStr);
    gXmlDSigSignedOutFilePickerElem.refresh();

    gXmlDSigSignedOutDocVerifyElem.hidden = false;

    XmlDigitalSigTool.logTrace("xmldsigffext_signXMLDocToFile():................End.");
    return signedXmlDoc;
}

function xmldsigffext_verifySignedXMLDocWithSharedKey(signedXmlDoc, xmlSignatureProps)
{
    XmlDigitalSigTool.logTrace("xmldsigffext_verifySignedXMLDocWithSharedKey():................Start.");

    var sharedKey = gXmlDSigEditorElem.signerSharedKey;
    if (!sharedKey || (sharedKey == "")) {
	sharedKey = propmptAndGetPassword(
		"Enter the Signing Key",
		"This document is signed with symmetric key - enter the key used to sign the document"
		)
	if (!sharedKey || (sharedKey == "")) { 
	    // alert("Password is missing - enter a password.");
    	    return false;
	}
	gXmlDSigEditorElem.signerSharedKey = sharedKey;
    }
    /*
    if (sharedKey == "") {
	alert("Password is missing - enter a password.");
    	return false;
    }
    */

    var isPassed = false;
    try {
    	isPassed = gXmlDSigTool.verifySignedXMLDocBySharedKey(
                        signedXmlDoc,
			sharedKey,
			xmlSignatureProps
                        );
    } catch (ex) {
    	XmlDigitalSigTool.logError("xmldsigffext_verifySignedXMLDocWithSharedKey(): failed to verify signed archive file - ex : " + ex + "");
	throw ex;
    }

    XmlDigitalSigTool.logTrace("xmldsigffext_verifySignedXMLDocWithSharedKey():................End.");
    return isPassed;
}


function xmldsigffext_verifySignedXMLDocByX509Cert(signedXmlDoc, xmlSignatureProps)
{
    // XmlDigitalSigTool.logTrace("xmldsigffext_verifySignedXMLDocByX509Cert():................Start.");


    var /* nsIX509Cert */ docSignerCert = null;
    var signerCertObj = new Object();
    var isPassed = false;
    try {
    	docSignerCert = gXmlDSigEditorElem.docSignerCert;
    	// XmlDigitalSigTool.logDebug("xmldsigffext_verifySignedXMLDocByX509Cert(): docSignerCert: " + docSignerCert + "");
	if (docSignerCert) {
    	XmlDigitalSigTool.logDebug("xmldsigffext_verifySignedXMLDocByX509Cert(): docSignerCert: " + docSignerCert.nickname + "");
	}
	signerCertObj.value = gXmlDSigEditorElem.docSignerCert;
    	isPassed = gXmlDSigTool.verifySignedXMLDocByX509Cert(
                        signedXmlDoc,
			signerCertObj,
			xmlSignatureProps
                        );
    } catch (ex) {
    	XmlDigitalSigTool.logError("xmldsigffext_verifySignedXMLDocByX509Cert(): failed to verify signed archive file - ex : " + ex + "");
	isPassed = false;
	// throw ex;
    }
    /*
    if (!docSignerCert) {
	docSignerCert = signerCertObj.value;
    	XmlDigitalSigTool.logDebug("xmldsigffext_verifySignedXMLDocByX509Cert(): signerCertObj.value: " + signerCertObj.value + "");
	if (docSignerCert) {
    	    gXmlDSigEditorElem.docSignerCert = docSignerCert;
    	    xmldsigffext_showXmlDocSignerCert(signerCertObj.value);
    	    XmlDigitalSigTool.logDebug("xmldsigffext_verifySignedXMLDocByX509Cert():x509Cert.dbKey: " + signerCertObj.value.dbKey + "");
	}
    }
    */

    // XmlDigitalSigTool.logTrace("xmldsigffext_verifySignedXMLDocByX509Cert():................End.");
    return isPassed;
}

function xmldsigffext_verifySignedXMLDoc()
{
    XmlDigitalSigTool.logTrace("xmldsigffext_verifySignedXMLDoc():................Start.");

    var /* nsIDOMDocument */ signedXmlDoc = gXmlDSigInputFilePickerElem.xmlDoc;
    // XmlDigitalSigTool.logDebug("xmldsigffext_verifySignedXMLDoc(): signedXmlDoc: " + signedXmlDoc + "");
    if (!signedXmlDoc) {
    	// alert("Input signed XML file is missing.");
    	XmlDigitalSigTool.logDebug("xmldsigffext_signXMLFile(): No input XML file is selected.");
    	throw("xmldsigffext_signXMLFile(): No input XML file is selected.");
    }

    var /* nsIPersistentProperties */ xmlSignatureProps = gXmlDSigEditorElem.getSignatureProperties();
    var isPassed = false;
    var credentialType = gXmlDSigEditorElem.credentialType;
    if (credentialType == "certificate") {
    	isPassed = xmldsigffext_verifySignedXMLDocByX509Cert(signedXmlDoc, xmlSignatureProps);
    }
    else {
    	isPassed = xmldsigffext_verifySignedXMLDocWithSharedKey(signedXmlDoc, xmlSignatureProps);
    }

    var errorMessage = null;
    if (!isPassed) {
	try {
	    var propKey = "errorMessage";
	    errorMessage = xmlSignatureProps.getStringProperty(propKey);
	} catch(ex) { }
	if (errorMessage) {
	    alert("XML Signature verification failed - " + errorMessage + "");
	}
    }
    XmlDigitalSigTool.logTrace("xmldsigffext_verifySignedXMLDoc():................End.");
    return isPassed;
}



function xmldsigffext_signXMLFileWithSharedKey(/* nsIPersistentProperties */ xmlSignatureProps)
{
    // XmlDigitalSigTool.logTrace("xmldsigffext_signXMLFileWithSharedKey():................Start.");


    var /* nsILocalFile */ inputXMLFile = gXmlDSigInputFilePickerElem.file;
    if (inputXMLFile == null) {
    	XmlDigitalSigTool.logError("xmldsigffext_signXMLFileWithSharedKey(): No input XML file is selected.");
    	return null;
    }

    var /* nsILocalFile */ outSignedXMLFile = gXmlDSigSignedOutFilePickerElem.file;
    if (outSignedXMLFile == null) {
    	XmlDigitalSigTool.logError("xmldsigffext_signXMLFileWithSharedKey(): failed to get outSignedXMLFile.");
        return null;
    }

    try {
    	gXmlDSigTool.signXMLFileBySharedKey(inputXMLFile, xmlSignatureProps, outSignedXMLFile);
    } catch (ex) {
    	// alert("xmldsigffext_signXMLFileWithSharedKey(): failed to create signed XML file - ex : " + ex + "");
    	XmlDigitalSigTool.logError("xmldsigffext_signXMLFileWithSharedKey(): failed to create signed XML file - ex : " + ex + "");
	throw ex;
    }

    // XmlDigitalSigTool.logTrace("xmldsigffext_signXMLFileWithSharedKey():................End.");

    return outSignedXMLFile;
}

function xmldsigffext_signXMLFileWithCert(/* nsIPersistentProperties */ xmlSignatureProps)
{
    XmlDigitalSigTool.logTrace("xmldsigffext_signXMLFileWithCert():................Start.");


    var /* nsIX509Cert */ signerCert;
    signerCert = gXmlDSigEditorElem.signerCert;
    if (signerCert == null) {
    	alert("xmldsigffext_signXMLFileWithCert(): null signer certificate - you must choose a signer certificate.");
    	XmlDigitalSigTool.logError("xmldsigffext_signXMLFileWithCert(): null signer certificate - you must choose a signer certificate.");
    	return null;
    }

    var /* nsILocalFile */ inputXMLFile = gXmlDSigInputFilePickerElem.file;
    if (inputXMLFile == null) {
    	XmlDigitalSigTool.logError("xmldsigffext_signXMLFileWithCert(): No input XML file is selected.");
    	return null;
    }

    var /* nsILocalFile */ outSignedXMLFile = gXmlDSigSignedOutFilePickerElem.file;
    if (outSignedXMLFile == null) {
    	XmlDigitalSigTool.logError("xmldsigffext_signXMLFileWithCert(): failed to get outSignedXMLFile.");
        return null;
    }

    try {
    	// Force token login - on windows the popup window for password is not coming up
    	xmldsigffext_loginToCertToken(signerCert);

    	// dumpProperties(xmlSignatureProps, "xmldsigffext_signXMLFileWithCert(): xmlSignatureParams:");
    	gXmlDSigTool.signXMLFileByX509Cert(inputXMLFile, signerCert, xmlSignatureProps, outSignedXMLFile);
    } catch (ex) {
    	// alert("xmldsigffext_signXMLFileWithCert(): failed to create signed XML file - ex : " + ex + "");
    	XmlDigitalSigTool.logError("xmldsigffext_signXMLFileWithCert(): failed to create signed XML file - ex : " + ex + "");
	throw ex;
    }

    XmlDigitalSigTool.logTrace("xmldsigffext_signXMLFileWithCert():................End.");

    return outSignedXMLFile;
}

function xmldsigffext_signXMLFile()
{
    XmlDigitalSigTool.logTrace("xmldsigffext_signXMLFile():................Start.");


    var /* nsIPersistentProperties */ xmlSignatureProps = gXmlDSigEditorElem.getSignatureProperties();
    var /* nsIPersistentProperties */ xmlSigProps = Components.classes["@mozilla.org/persistent-properties;1"].
                    createInstance(Components.interfaces.nsIPersistentProperties);

    var /* nsILocalFile */ inputXMLFile = gXmlDSigInputFilePickerElem.file;
    if (inputXMLFile == null) {
    	XmlDigitalSigTool.logError("xmldsigffext_signXMLFile(): No input XML file is selected.");
    	alert("xmldsigffext_signXMLFile(): No input XML file is selected.");
    	return null;
    }

    var /* nsILocalFile */ outSignedXMLFile = null;
    if (gXmlDSigSignedOutFilePickerElem.value == "") {
	xmldsigffext_autoSelectOutSignedFile(inputXMLFile);
    }
    outSignedXMLFile = gXmlDSigSignedOutFilePickerElem.file;
    if (outSignedXMLFile == null) {
    	XmlDigitalSigTool.logError("xmldsigffext_signXMLFile(): failed to get outSignedXMLFile.");
    	alert("xmldsigffext_signXMLFile(): failed to get outSignedXMLFile.");
        return null;
    }
    XmlDigitalSigTool.logDebug("xmldsigffext_signXMLFile(): outSignedXMLFile: " + outSignedXMLFile.path + "");


    // var credentialType = xmldsigffext_getUserCredentialType();
    var credentialType = gXmlDSigEditorElem.credentialType;
    if (credentialType == "certificate") {
    	outSignedXMLFile = xmldsigffext_signXMLFileWithCert(xmlSignatureProps);
    }
    else if (credentialType == "password") {
    	var sharedKey = gXmlDSigEditorElem.signerSharedKey;
        if (sharedKey.length == 0) {
    	    alert("xmldsigffext_signXMLFileWithSharedKey(): shared key is missing.");
    	    XmlDigitalSigTool.logError("xmldsigffext_signXMLFileWithSharedKey(): shared key is missing.");
    	    return null;
        }
    	outSignedXMLFile = xmldsigffext_signXMLFileWithSharedKey(xmlSignatureProps);
    }
    else {
    	outSignedXMLFile = null;
    }

    if (!outSignedXMLFile) {
    	XmlDigitalSigTool.logError("xmldsigffext_signXMLFile(): failed to sign input XML file.");
	return null;
    }

    gXmlDSigSignedOutFilePickerElem.refresh();
    outSignedXMLFile = gXmlDSigSignedOutFilePickerElem.file;
    if (!outSignedXMLFile || !outSignedXMLFile.exists() || (outSignedXMLFile.fileSize <= 0)) {
    	XmlDigitalSigTool.logError("xmldsigffext_signXMLFile(): failed to create Signed XML file.");
    	// alert("xmldsigffext_signXMLFile(): failed to create Signed XML file.");
	return null;
    }

    XmlDigitalSigTool.logTrace("xmldsigffext_signXMLFile():................End.");

    return gXmlDSigSignedOutFilePickerElem.file;
}

function propmptAndGetPassword(aPromptWinTitle, aPromptMsg)
{
    var checkStateMsg = null;
    var checkStateObj = new Object();
    checkStateObj.value = null;
    var passwordObj = new Object();
    passwordObj.value = null;

    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService();
    promptService = promptService.QueryInterface(Components.interfaces.nsIPromptService);
    var dialogOk = promptService.promptPassword(
			window,
			aPromptWinTitle,
			aPromptMsg,
			passwordObj,
			checkStateMsg,
			checkStateObj
		     	);
    if (!dialogOk) {
	return null;
    }
    return passwordObj.value;
}

function xmldsigffext_verifySignedXMLFileWithSharedKey(xmlSignatureProps)
{
    XmlDigitalSigTool.logTrace("xmldsigffext_verifySignedXMLFileWithSharedKey():................Start.");


    var signedXmlFile = gXmlDSigInputFilePickerElem.file;

    var sharedKey = gXmlDSigEditorElem.signerSharedKey;
    if (sharedKey == "") {
	var promptWinTitle = "Enter the Signing Key";
	var promptMsg = "This document is signed with symmetric key - enter the key used to sign the document"
	sharedKey = propmptAndGetPassword( promptWinTitle, promptMsg)
	if (!sharedKey || (sharedKey == "")) { 
	    // alert("Password is missing - enter a password.");
    	    return false;
	}
	gXmlDSigEditorElem.signerSharedKey = sharedKey;
    }

    var isPassed = false;
    try {
    	/*
        boolean verifySignedXMLFileByX509Cert(
	    	in nsILocalFile aSignedXmlFile,
		in AString sharedKey,
		in nsIPersistentProperties aSignatureProps
		);
	*/
    	isPassed = gXmlDSigTool.verifySignedXMLFileBySharedKey(
                        signedXmlFile,
			sharedKey,
			xmlSignatureProps
                        );
    } catch (ex) {
    	XmlDigitalSigTool.logError("xmldsigffext_verifySignedXMLFileWithSharedKey to verify signed XML file - ex : " + ex + "");
	throw ex;
    }

    XmlDigitalSigTool.logTrace("xmldsigffext_verifySignedXMLFileWithSharedKey():................Start.");
    return isPassed;
}

function xmldsigffext_verifySignedXMLFileWithX509Cert(xmlSignatureProps)
{
    XmlDigitalSigTool.logTrace("xmldsigffext_verifySignedXMLFileWithX509Cert():................Start.");

    var signedXmlFile = gXmlDSigInputFilePickerElem.file;

    var /* nsIX509Cert */ docSignerCert = null;
    var signerCertObj = new Object();
    var isPassed = false;
    try {
    	docSignerCert = gXmlDSigEditorElem.docSignerCert;
	if (docSignerCert) {
    	XmlDigitalSigTool.logError("xmldsigffext_verifySignedXMLFileWithX509Cert(): docSignerCert: " + docSignerCert.nickname + "");
	}
	signerCertObj.value = gXmlDSigEditorElem.docSignerCert;
    	isPassed = gXmlDSigTool.verifySignedXMLFileByX509Cert(
                        signedXmlFile,
			signerCertObj,
			xmlSignatureProps
                        );
    } catch (ex) {
    	XmlDigitalSigTool.logError("xmldsigffext_verifySignedXMLFileWithX509Cert(): failed to verify signed XML file - ex : " + ex + "");
	throw ex;
    }
    /*
    if (!signerCert) {
    	// gXmlDSigDocSignerCertElem.cert = signerCertObj.value;
    	if (signerCertObj.value) {
    	    xmldsigffext_showXmlDocSignerCert(signerCertObj.value);
    	    XmlDigitalSigTool.logDebug("xmldsigffext_verifySignedXMLFileWithX509Cert():x509Cert.dbKey: " + signerCertObj.value.dbKey + "");
    	}
    }
    */

    XmlDigitalSigTool.logTrace("xmldsigffext_verifySignedXMLFileWithX509Cert():................End.");
    return isPassed;
}

function xmldsigffext_verifySignedXMLFile()
{
    XmlDigitalSigTool.logTrace("xmldsigffext_verifySignedXMLFile():................Start.");

    var /* nsIPersistentProperties */ xmlSignatureProps = gXmlDSigEditorElem.getSignatureProperties();
    // gXmlDSigEditorElem.dumpProperties(xmlSignatureProps, "Verification Props:");

    var isPassed = false;
    var credentialType = gXmlDSigEditorElem.credentialType;
    XmlDigitalSigTool.logDebug("xmldsigffext_verifySignedXMLFile(): credentialType: " + credentialType + "");
    if ("certificate" == credentialType) {
    	isPassed = xmldsigffext_verifySignedXMLFileWithX509Cert(xmlSignatureProps);
    }
    else {
    	isPassed = xmldsigffext_verifySignedXMLFileWithSharedKey(xmlSignatureProps);
    }

    XmlDigitalSigTool.logTrace("xmldsigffext_verifySignedXMLFile():................End.");
    return isPassed;
}


function xmldsigffext_loadAndVerifySignedDoc()
{
    xmldsigffext_setInputXMLFilePath(gXmlDSigSignedOutFilePickerElem.value);
    gXmlDSigSignedOutFilePickerElem.value = "";
    xmldsigffext_xmlDocFileChangeHandler();
}

