/* @(#) $Id: XmlMultiDigitalSigParamDialog.js,v 1.7 2011/07/02 17:14:10 subrata Exp $ */

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is  Avaya Labs Research, Avaya Inc. Code.
 *
 * The Initial Developer of the Original Code is
 *     Subrata Mazumdar, Avaya Labs Research, Avaya Inc.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Subrata Mazumdar (mazum@avaya.com)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


function xmlmultidsigparam_initOnLoad()
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigparam_initOnLoad():................Start.");

    try {

    XmlMultiDSigUtil.initXPCOMServices();

    var sigParamGridElem = document.getElementById("xmldsigffext.form.multisig.param.grid");
    var /* NodeList */ xmlSigParamList = sigParamGridElem.getElementsByAttribute("sigParamName", "*");
    XmlMultiDSigUtil.logDebug("xmlmultidsigparam_initOnLoad(): xmlSigParamList.length: " + xmlSigParamList.length + "");
    for (var i = 0; i < xmlSigParamList.length; i++) {
    	var xmlSigParamElem = xmlSigParamList.item(i);
    	if (xmlSigParamElem.refresh) {
	    xmlSigParamElem.refresh();
    	}
    }
    XmlMultiDSigUtil.logDebug("xmlmultidsigparam_initOnLoad(): window.arguments.length: " + window.arguments.length + "");

    xmlmultidsigparam_updateWithDialogParams();



    XmlMultiDSigUtil.logTrace("xmlmultidsigparam_initOnLoad():................End.");
    } catch (ex) {
    	XmlMultiDSigUtil.logError("xmlmultidsigparam_initOnLoad(): failed - ex: " + ex + "");
    }
}

function xmlmultidsigparam_updateWithDialogParams()
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigparam_updateWithDialogParams():................Start.");

    var dialogParams = window.arguments[0].QueryInterface(Components.interfaces.nsIDialogParamBlock);

    var multiSigJsonParams = XmlMultiDSigUtil.multiSigDialogParams2JsonParams(dialogParams);
    XmlMultiDSigUtil.dumpMultiSigJsonParams(multiSigJsonParams);
    /*
    // Format for multiSigJsonParams:
    var multiSigJsonParams = {
		"inputXmlDocFilePath"	: inXMLFilePath,
		"outXmlDocFilePath"	: outXMLFilePath,
		"contentElementURI"	: contentElementURI,
		"signatureType"		: signatureType,
		"credentialType"	: credentialType,
		"canonicalizationMethod" : canonicalizationMethod,
		"totSignerX509CertCnt"	: signerCnt,
		"signerX509CertList"	: signerX509CertList
	};
    */


    var xmlFilePickerElem = document.getElementById("xmldsigffext.form.multisig.param.xmldoc.infile.path");
    if (multiSigJsonParams.inputXmlDocFilePath) {
    	xmlFilePickerElem.filepath = multiSigJsonParams.inputXmlDocFilePath;
	xmlFilePickerElem.disabled = true;
    	xmlmultidsigparam_handleInputXmlDocFileChange(xmlFilePickerElem);
    }
    var xmlDocContentIdElem = document.getElementById("xmldsigffext.form.multisig.param.contentid");
    /*
    if (multiSigJsonParams.contentElementURI) {
    	xmlDocContentIdElem.value = multiSigJsonParams.contentElementURI;
    }
    */
    var sigTypeElem = document.getElementById("xmldsigffext.form.multisig.param.signature.type");
    if (multiSigJsonParams.signatureType) {
    	sigTypeElem.value = multiSigJsonParams.signatureType;
    }
    var credTypeElem = document.getElementById("xmldsigffext.form.multisig.param.credential.type");
    if (multiSigJsonParams.credentialType) {
    	credTypeElem.value = multiSigJsonParams.credentialType;
    }
    var canonMethodElem = document.getElementById("xmldsigffext.form.multisig.param.canonmethod");
    if (multiSigJsonParams.canonicalizationMethod) {
    	canonMethodElem.value = multiSigJsonParams.canonicalizationMethod;
    }

    var signerCertAllowElem = document.getElementById("xmldsigffext.form.multisig.param.signercert.allow");
    xmlmultidsigparam_handleSignerCertAllowChange(signerCertAllowElem);

    XmlMultiDSigUtil.logTrace("xmlmultidsigparam_updateWithDialogParams():................End.");
}

function xmlmultidsigparam_handleInputXmlDocFileChange(aXmlDSigInputFilePickerElem, ev)
{

    XmlMultiDSigUtil.logTrace("xmlmultidsigparam_handleInputXmlDocFileChange():................Start.");
    
    var inputXmlFile = aXmlDSigInputFilePickerElem.file;
    if (inputXmlFile == null) {
    	// alert("xmlmultidsigparam_handleInputXmlDocFileChange(): Input XML file path is missing.");
    	XmlMultiDSigUtil.logError("xmlmultidsigparam_handleInputXmlDocFileChange(): Input XML file path is missing.");
    	return;
    }
    if (!inputXmlFile.exists()) {
    	// alert("xmldsigffext_inputXmlDocFileChangeHandler(): Input XML file does not exists.");
    	XmlMultiDSigUtil.logError("xmlmultidsigparam_handleInputXmlDocFileChange(): Input XML file does not exists.");
    	return;
    }

    var /* nsIDOMDocument */ xmlDoc = null;
    try {
    	// xmlDoc = XmlMultiDSigUtil.mXmlDSigTool.readXMLDocFromFile(inputXmlFile);
    	xmlDoc = XmlMultiDSigUtil.readXMLDocFromFile(inputXmlFile);
    } catch (ex) {
    	alert("xmlmultidsigparam_handleInputXmlDocFileChange(): Not a valid XML file - parsing error.");
    	XmlMultiDSigUtil.logError("xmlmultidsigparam_handleInputXmlDocFileChange(): Not a valid XML file - parsing error - ex: " + ex + "");
    	return;
    }
    if (!xmlDoc) {
    	alert("xmlmultidsigparam_handleInputXmlDocFileChange(): Not a valid XML file.");
    	XmlMultiDSigUtil.logError("xmlmultidsigparam_handleInputXmlDocFileChange(): Not a valid XML file.");
    	return;
    }

    aXmlDSigInputFilePickerElem.xmlDoc = xmlDoc;

    var contentElemIdMenuElem = document.getElementById("xmldsigffext.form.multisig.param.contentid");
    contentElemIdMenuElem.docRootElem = xmlDoc;
    contentElemIdMenuElem.selectAnyNonRootElemWithId();
    xmlmultidsigparam_handleContentIdMenuChange(contentElemIdMenuElem);

    var xmlDocSigElemList = xmlDoc.getElementsByTagName("ds:Signature");
    if (xmlDocSigElemList.length <= 0) {
    	xmlDocSigElemList = xmlDoc.getElementsByTagName("Signature");
    }

    XmlMultiDSigUtil.logTrace("xmlmultidsigparam_handleInputXmlDocFileChange():................End.");
}

function xmlmultidsigparam_handleContentIdMenuChange(aContentIdMenuElem, ev)
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigparam_handleContentIdMenuChange():................Start.");
    var contentURI = aContentIdMenuElem.value;
    if (!contentURI) {
    	XmlMultiDSigUtil.logTrace("xmlmultidsigparam_handleContentIdMenuChange():................End(0).");
    	return;
    }
    var contentId = contentURI.substring(1);

    var xmlFilePickerElem = document.getElementById("xmldsigffext.form.multisig.param.xmldoc.infile.path");
    // var xmlDoc = xmlFilePickerElem.xmlDoc.cloneNode(true);
    var xmlDoc = xmlFilePickerElem.xmlDoc;
    XmlMultiDSigUtil.logDebug("xmlmultidsigparam_handleContentIdMenuChange(): xmlDoc:\n" + XmlMultiDSigUtil.mXmlSerializer.serializeToString(xmlDoc) + "");

    /*
    var contentElemx = null;
    if (window.jQuery) {
    contentElemx = $(xmlDoc).("#" + contentId);
    }
    */
    // var contentElem = xmlDoc.getElementById(contentId);
    var contentElem = XmlMultiDSigUtil.getDocElementById(xmlDoc, contentId);
    XmlMultiDSigUtil.logDebug("xmlmultidsigparam_handleContentIdMenuChange(): contentURI:|" + contentURI + "| contentId:|" + contentId + "| contentElem: " + contentElem + "");

    XmlMultiDSigUtil.logTrace("xmlmultidsigparam_handleContentIdMenuChange():................End.");
}

function xmlmultidsigparam_handleSignerCertAllowChange(aSignerCertAllowElem, ev)
{
    var signerCertPickerElem = document.getElementById("xmldsigffext.form.multisig.param.signercert.menu");
    signerCertPickerElem.hidden = !aSignerCertAllowElem.checked;
    /*
    if (!aSignerCertAllowElem.checked) {
    	signerCertPickerElem.selectedCert = null;
    }
    */
}

function xmlmultidsigparam_getSignatureParameters()
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigparam_getSignatureParameters():................Start.");

    var sigParamGridElem = document.getElementById("xmldsigffext.form.multisig.param.grid");

    var multiSigJsonParams = XmlMultiDSigUtil.getXmlSigJSONParams(sigParamGridElem);

    var signerCertAllowElem = document.getElementById("xmldsigffext.form.multisig.param.signercert.allow");
    var signerCertPickerElem = document.getElementById("xmldsigffext.form.multisig.param.signercert.menu");

    var selectedCert = signerCertPickerElem.selectedCert;
    XmlMultiDSigUtil.logDebug("xmlmultidsigparam_getSignatureParameters(): signerCertAllowElem.checked: " + signerCertAllowElem.checked + "");
    XmlMultiDSigUtil.logDebug("xmlmultidsigparam_getSignatureParameters(): selectedCert: " + selectedCert + "");

    var signerX509CertList = [];
    if (signerCertAllowElem.checked && signerCertPickerElem.selectedCert) {
    	signerX509CertList.push(signerCertPickerElem.selectedCert);
    	// signerX509CertList.push(signerCertPickerElem.selectedCert);
    }
    XmlMultiDSigUtil.logDebug("xmlmultidsigparam_getSignatureParameters(): signerX509CertList.length: " + signerX509CertList.length + "");
    multiSigJsonParams.signerX509CertList = signerX509CertList;

    XmlMultiDSigUtil.logTrace("xmlmultidsigparam_getSignatureParameters():................End.");
    return multiSigJsonParams;
}

function xmlmultidsigparam_onAccept()
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigparam_onAccept():................Start.");

    try {
    	XmlMultiDSigUtil.logDebug("xmlmultidsigparam_onAccept(): window.arguments.length: " + window.arguments.length + "");

    	var dialogParams = window.arguments[0].QueryInterface(Components.interfaces.nsIDialogParamBlock);

    	var multiSigJsonParams = xmlmultidsigparam_getSignatureParameters();
    	XmlMultiDSigUtil.dumpMultiSigJsonParams(multiSigJsonParams);

    	XmlMultiDSigUtil.multiSigJsonParams2ToDailogParams(multiSigJsonParams, dialogParams);

    	var inputXmlDoc = XmlMultiDSigUtil.readXMLDocFromFilePath(multiSigJsonParams.inputXmlDocFilePath);
    	var presignedXmlDoc = XmlMultiDSigUtil.cmdAddSignerToXmlDoc(inputXmlDoc, multiSigJsonParams);

    	dialogParams.SetInt(0, 1); // Accept
    	window.close(0);

    } catch (ex) {
    	dialogParams.SetInt(0, 0); // Failed
	alert("Failed to build Signature parameters from GUI elements.");
    	XmlMultiDSigUtil.logError("xmlmultidsigparam_onAccept(): Failed to build Signature parameters from GUI elements - ex: " + ex + "");
	throw ex;
    }

    XmlMultiDSigUtil.logTrace("xmlmultidsigparam_onAccept():................End.");
}

function xmlmultidsigparam_onCancel()
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigparam_onCancel():................Start.");

    try {
    	XmlMultiDSigUtil.logDebug("xmlmultidsigparam_onCancel(): window.arguments.length: " + window.arguments.length + "");

    	var dialogParams = window.arguments[0].QueryInterface(Components.interfaces.nsIDialogParamBlock);
    	dialogParams.SetInt(0, 0); // Cancel 

    	window.close(0);
    } catch (ex) {
    	XmlMultiDSigUtil.logError("xmlmultidsigparam_onCancel(): ex: " + ex + "");
    }

    XmlMultiDSigUtil.logTrace("xmlmultidsigparam_onCancel():................End.");
}


